<?php
require_once '../model/seguridad/seguridad.php';
require_once '../model/database.php';
require_once '../model/adopcion.entidad.php';
require_once '../model/adopcion.model.php';
require_once '../model/origendestino.entidad.php';
require_once '../model/origendestino.model.php';
require_once '../model/codigo.entidad.php';
require_once '../model/codigo.model.php';
require_once '../model/grupohectarea.entidad.php';
require_once '../model/grupohectarea.model.php';

$controller = !empty($_GET['c']) ? $_GET['c'] : null;
$action = !empty($_GET['a']) ? $_GET['a'] : null;
$token = !empty($_GET['accessToken']) ? $_GET['accessToken'] : null;

$ds = new API($token);

if (!empty($controller) && !empty($action)) {
    $exc = sprintf('%s_%s', $controller, $action);
    if (method_exists($ds, $exc)) {
        call_user_func(array($ds, $exc));
    } else {
        $ds->invokeError();
    }
} else {
    $ds->sayHello();
}
class API
{

    private $token;

    private $adopcion_model;
    private $origendestino_model;
    private $codigo_model;
    private $grupohectarea_model;

    function __construct($token)
    {
        $this->token = $token;
        $this->validarToken();
        $this->adopcion_model = new AdopcionModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->codigo_model = new CodigoModel();
        $this->grupohectarea_model = new GrupoHectareaModel();
    }
    private function validarToken()
    {
        if ($this->token != '11128358cc0bf0eb27f0d06c4de3c667') {
            $this->printRes(false, 'Token inválido');
        }
    }

    function MetodoPago_Listar()
    {
        $rs = array(
            array('codigo' => 1, 'texto' => 'Transferencia'),
            array('codigo' => 2, 'texto' => 'Paypal'),
            array('codigo' => 3, 'texto' => 'Otros')
        );
        $this->printRes(true, 'Lista de metodos de pago.', $rs);
    }
    function TipoAdopcion_Listar()
    {
        $rs = array(
            array('codigo' => 1, 'texto' => 'Donación'),
            array('codigo' => 2, 'texto' => 'Donación árboles'),
            array('codigo' => 3, 'texto' => 'Donación hectáreas'),
            array('codigo' => 4, 'texto' => 'Adopción árboles'),
            array('codigo' => 5, 'texto' => 'Adopción hectáreas')
        );
        $this->printRes(true, 'Lista de tipos de adopción.', $rs);
    }

    function Arbol_Listar()
    {
        $arboles = $this->codigo_model->Listar();
        $rs = [];
        if (!empty($arboles)) {
            foreach ($arboles as $a) {
                $texto = sprintf(
                    '%s - %s - %s/%s (Ø: %scm, h: %sm)',
                    $a->sCodCodigo,
                    $a->Familia,
                    $a->sCodNombre,
                    $a->sCodNombreCientifico,
                    $a->nCodDiametro,
                    $a->nCodAltura
                );
                $rs[] = array('codigo' => (int)$a->Codigo_Id, 'texto' => $texto);
            }
        }
        $this->printRes(true, 'Lista de árboles/hectáreas.', $rs);
    }

    function Zona_Listar()
    {
        $rs = array(
            array('codigo' => 1, 'texto' => 'Guardabosque de agua'),
            array('codigo' => 2, 'texto' => 'Guardabosque de tierra'),
            array('codigo' => 3, 'texto' => 'Guardabosque de aire'),
            array('codigo' => 4, 'texto' => 'Guardabosque ancestral')
        );
        $this->printRes(true, 'Lista de zonas.', $rs);
    }

    function Adopcion_Registrar()
    {

        $this->requirePOST();

        $nAdoCliente_Id = $this->obtenerClienteId();
        $nAdoTipoAdopcion_Id = !empty($_POST['tipo']) ? $_POST['tipo'] : null;
        $sAdoMotivo = !empty($_POST['motivo']) ? $_POST['motivo'] : null;
        $nAdoEsRegalo = isset($_POST['esRegalo']) ? (int)$_POST['esRegalo'] : null;
        $nAdoCodigo_Id = !empty($_POST['arbol']) ? $_POST['arbol'] : null;
        if ($nAdoTipoAdopcion_Id == 2) {
            $nAdoCodigo_Id = $this->obtenerCodigoId($nAdoCodigo_Id);
        }
        $nAdoAnios = !empty($_POST['anios']) ? $_POST['anios'] : null;
        $nAdoGrupoHectarea_Id = !empty($_POST['grupo']) ? $_POST['grupo'] : null;
        if ($nAdoTipoAdopcion_Id == 3) {
            $nAdoGrupoHectarea_Id = $this->obtenerGrupoHectareaId($nAdoGrupoHectarea_Id);
        }
        $sAdoDocumentoFE = ''; //!empty($_POST['documentoFE'])?$_POST['documentoFE']:'';
        $nAdoPrecio = !empty($_POST['precio']) ? $_POST['precio'] : null;
        /* $nAdoTipoMoneda_Id = !empty($_POST['moneda'])?$_POST['moneda']:1;//soles
        
        if($nAdoTipoMoneda_Id==1){
            $nAdoTipoCambio = 1;
        }else{
            $cambio = !empty($_POST['tipoCambio'])?$_POST['tipoCambio']:null;
            if(empty($cambio)){
                $this->printRes(false,'Parametro tipoCambio es requerido.');
            }
            $nAdoTipoCambio = (double)$cambio;
        } */
        $nAdoTipoMoneda_Id = 2; //dolares
        $nAdoTipoCambio = 3.95;

        $sAdoCerificado = !empty($_POST['certificado']) ? $_POST['certificado'] : '';
        if (!empty($sAdoCerificado)) {
            if ($this->validarPDF($sAdoCerificado)) {
                $sAdoCerificado = sprintf('data:application/pdf;base64,%s', $sAdoCerificado);
            } else {
                $this->printRes(false, 'Parametro certificado. Archivo PDF no es válido.');
            }
        }
        $nAdoMetodoPago_Id = !empty($_POST['tipoPago']) ? $_POST['tipoPago'] : null;
        $sAdoPaypalToken = !empty($_POST['ppToken']) ? $_POST['ppToken'] : '';
        $sAdoPaypalPayerID = !empty($_POST['ppPayerID']) ? $_POST['ppPayerID'] : '';
        $sAdoPaypalPaymentID = !empty($_POST['ppPaymentID']) ? $_POST['ppPaymentID'] : '';
        $dAdoFechaPago = !empty($_POST['fechaPago']) ? $_POST['fechaPago'] : null;

        if (empty($nAdoTipoAdopcion_Id)) {
            $this->printRes(false, 'Parametro tipo es requerido.');
        }
        switch ((int)$nAdoTipoAdopcion_Id) {
            case 1:
                break;
            case 2:
            case 4:
                if (empty($sAdoMotivo)) {
                    $this->printRes(false, 'Tipo es árbol. Parametro motivo es requerido.');
                }
                if ($nAdoEsRegalo === null) {
                    $this->printRes(false, 'Tipo es árbol. Parametro esRegalo es requerido.');
                }
                if (empty($nAdoCodigo_Id)) {
                    $this->printRes(false, 'Tipo es árbol. Parametro arbol es requerido.');
                }
                break;
            case 3:
            case 5:
                /* if(empty($nAdoCodigo_Id)){
                    $this->printRes(false,'Tipo es hectárea. Parametro arbol es requerido.');
                } */
                if (empty($nAdoGrupoHectarea_Id)) {
                    $this->printRes(false, 'Tipo es hectárea. Parametro grupo es requerido.');
                }
                break;
        }
        if (empty($nAdoAnios)) {
            $this->printRes(false, 'Parametro anios es requerido.');
        }
        if (empty($nAdoMetodoPago_Id)) {
            $this->printRes(false, 'Parametro tipoPago es requerido.');
        }
        if (empty($nAdoPrecio)) {
            $this->printRes(false, 'Parametro precio es requerido.');
        }

        if ($nAdoMetodoPago_Id == '2') {
            if (empty($sAdoPaypalToken)) {
                $this->printRes(false, 'Tipo de Pago es Paypal. Parametro ppToken es requerido.');
            }
            if (empty($sAdoPaypalPayerID)) {
                $this->printRes(false, 'Tipo de Pago es Paypal. Parametro ppPayerID es requerido.');
            }
            if (empty($sAdoPaypalPaymentID)) {
                $this->printRes(false, 'Tipo de Pago es Paypal. Parametro ppPaymentID es requerido.');
            }
        }
        if (empty($dAdoFechaPago)) {
            $this->printRes(false, 'Parametro fechaPago es requerido.');
        }

        $sAdoCerificado = $this->ObtnerPathImagen($sAdoCerificado);

        $ado = new Adopcion();
        $ado->__set('dAdoFecha', !empty($_POST['dAdoFecha']) ? $_POST['dAdoFecha'] : date('d-m-Y'));
        $ado->__set('nAdoCliente_Id', $nAdoCliente_Id);
        $ado->__set('nAdoTipoAdopcion_Id', $nAdoTipoAdopcion_Id);
        $ado->__set('sAdoMotivo', $sAdoMotivo);
        $ado->__set('nAdoEsRegalo', $nAdoEsRegalo);
        $ado->__set('nAdoCodigo_Id', $nAdoCodigo_Id);
        $ado->__set('nAdoAnios', $nAdoAnios);
        $ado->__set('nAdoGrupoHectarea_Id', $nAdoGrupoHectarea_Id);
        $ado->__set('sAdoDocumentoFE', $sAdoDocumentoFE);
        $ado->__set('nAdoPrecio', $nAdoPrecio);
        $ado->__set('nAdoTipoMoneda_Id', $nAdoTipoMoneda_Id);
        $ado->__set('nAdoTipoCambio', $nAdoTipoCambio);
        $ado->__set('sAdoCerificado', $sAdoCerificado);
        $ado->__set('nAdoMetodoPago_Id', $nAdoMetodoPago_Id);
        $ado->__set('sAdoPaypalToken', $sAdoPaypalToken);
        $ado->__set('sAdoPaypalPayerID', $sAdoPaypalPayerID);
        $ado->__set('sAdoPaypalPaymentID', $sAdoPaypalPaymentID);
        $ado->__set('dAdoFechaPago', $dAdoFechaPago);
        $ado->__set('nAdoEstado', 1);
        $ado->__set('nAdoEliminado', 0);
        $ado->__set('Usuario_Id', 1); //$_SESSION['usu_codigo']

        //die();
        $Adopcion_Id = $this->adopcion_model->Crear($ado);

        if (!empty($Adopcion_Id)) {
            $this->printRes(true, 'Adopción registrada correctamente.', array('id' => (int)$Adopcion_Id));
        } else {
            $this->printRes(false, 'No se registro la adopción.');
        }
    }

    private function ObtnerPathImagen($post_param)
    {
        $rnd = md5(mt_rand() * time());
        $fx = sprintf('./uploads/cert_%s.pdf', $rnd);
        if (preg_match('/^data/i', $post_param)) {
            $encoded_image = explode(",", $post_param)[1];
            $decoded_image = base64_decode($encoded_image);
            file_put_contents("./.$fx", $decoded_image);
        } else if (preg_match('/clear/i', $post_param) || $post_param == '') {
            /* if(file_exists($fx)){
				unlink($fx);
			} */
            $fx = '';
        } else {
            $fx = $post_param;
        }
        return $fx;
    }
    private function isBase64Encoded($string)
    {
        if (!is_string($string)) {
            // if check value is not string.
            // base64_decode require this argument to be string, if not then just return `false`.
            // don't use type hint because `false` value will be converted to empty string.
            return false;
        }

        $decoded = base64_decode($string, true);
        if (false === $decoded) {
            return false;
        }

        /* if (json_encode([$decoded]) === false) {
            return false;
        } */

        return true;
    }

    private function validarPDF($file_base64)
    {
        if (!$this->isBase64Encoded($file_base64)) {
            $this->printRes(false, 'Parametro certificado. No es base64.');
        }

        $file = base64_decode($file_base64);
        $f = finfo_open();
        $mime_type = strtolower(finfo_buffer($f, $file, FILEINFO_MIME_TYPE));
        return $mime_type == 'application/pdf';
    }

    private function obtenerCodigoId()
    {
        $codigo_arbol = !empty($_POST['arbol']) ? $_POST['arbol'] : null;
        if (!empty($codigo_arbol)) {
            $arbol = $this->codigo_model->BuscarPorCodigo($codigo_arbol);
            if (!empty($arbol)) {
                return $arbol->Codigo_Id;
            } else {
                $this->printRes(false, sprintf('Código de arbol "%s" es inválido.', $codigo_arbol));
            }
        } else {
            $this->printRes(false, 'Parametro arbol es requerido.');
        }
    }
    private function obtenerGrupoHectareaId()
    {
        $codigo_grupo = !empty($_POST['grupo']) ? $_POST['grupo'] : null;
        if (!empty($codigo_grupo)) {
            $grupohectarea = $this->grupohectarea_model->BuscarPorCodigo($codigo_grupo);
            if (!empty($grupohectarea)) {
                return $grupohectarea->GrupoHectarea_Id;
            } else {
                $this->printRes(false, sprintf('Código de grupo "%s" es inválido.', $codigo_grupo));
            }
        } else {
            $this->printRes(false, 'Parametro grupo es requerido.');
        }
    }

    private function obtenerClienteId()
    {

        $email = !empty($_POST['cliente_correo']) ? $_POST['cliente_correo'] : null;

        if (is_null($email)) {
            $this->printRes(false, 'Parametro cliente_correo es requerido.');
        }

        $emailInDB = $this->origendestino_model->getByEmail($email);

        //Validar que el email sea unico
        // if (count($emailInDB) > 0) {
        //     if ($_POST['tipo'] == 1 || $_POST['tipo'] == 3) {
        //         $cliente = $emailInDB[0];
        //         return $cliente->OrigenDestino_Id;
        //     } else {
        //         $this->printRes(false, sprintf('El email "%s" ya se encuentra registrado.', $email));
        //     }
        // }

        if (count($emailInDB) > 0) {
            $cliente = $emailInDB[0];
            return $cliente->OrigenDestino_Id;
        }

        $documento = !empty($_POST['cliente_documento']) ? $_POST['cliente_documento'] : '00000000';

        //Validar de la DB
        $search = $this->origendestino_model->getByDocument($documento);

        //Comprobar si esta vacio y el email no esta regisradop
        if (!empty($search) && count($emailInDB) < 0) {
            $cliente = $search;
            return $cliente->OrigenDestino_Id;
        } else {
            //registrar nuevo cliente
            $pro = new Origendestino();

            $nProcliTipoDoc = !empty($_POST['cliente_tipodoc']) ? $_POST['cliente_tipodoc'] : null;
            $sODRucDni = count($emailInDB) < 0 ? $documento : null;
            $sODNombre = !empty($_POST['cliente_nombre']) ? $_POST['cliente_nombre'] : null;
            $sProcliNomComercial = !empty($_POST['cliente_comercial']) ? $_POST['cliente_comercial'] : $sODNombre;
            $sProcliDireccion = !empty($_POST['cliente_direccion']) ? $_POST['cliente_direccion'] : 'n/a';
            $nProcliTelefono = !empty($_POST['cliente_telefono']) ? $_POST['cliente_telefono'] : 'n/a';
            $sProcliCorreo = !empty($_POST['cliente_correo']) ? $_POST['cliente_correo'] : 'n/a';
            $sProcliContacto = !empty($_POST['cliente_contacto']) ? $_POST['cliente_contacto'] : 'n/a';
            $nProcliDiasCredito = 0;


            if (empty($nProcliTipoDoc)) {
                $this->printRes(false, 'Parametro cliente_tipodoc es requerido.');
            }

            if (empty($sODNombre)) {
                $this->printRes(false, 'Parametro cliente_nombre es requerido.');
            }
            if (!empty($_POST['cliente_pais'])) {
                //ISO 3166-1 alfa-2
                //buscar pais con iso
                if (!preg_match('/^[a-zA-Z]{2}$/i', $_POST['cliente_pais'])) {
                    $this->printRes(false, 'Formato de parametro cliente_nombre es inváliddo.');
                }
                $nODPais_Id = (int)$this->origendestino_model->getPaisIdByISO($_POST['cliente_pais']);
            } else {
                $nODPais_Id = 173; //peru
            }
            $nODIdioma_Id = !empty($_POST['cliente_idioma']) ? $_POST['cliente_idioma'] : 1; //espanol
            $nProcliDepId = null;
            $nProcliDepName = null;
            $nProcliProvId = null;
            $nProcliProvName = null;
            $nProcliDistId = null;
            $nProcliDistName = null;

            $pro->__SET('nODTipo', 2); //cliente
            $pro->__SET('nODTipoDoc', $nProcliTipoDoc);
            $pro->__SET('sODRucDni', $sODRucDni);
            $pro->__SET('sODNombre', $sODNombre);
            $pro->__SET('sODNombreComercial', $sProcliNomComercial);
            $pro->__SET('sODDireccion', $sProcliDireccion);
            $pro->__SET('sODTelefono', $nProcliTelefono);
            $pro->__SET('sODCorreo', $sProcliCorreo);
            $pro->__SET('sODContacto', $sProcliContacto);
            $pro->__SET('nODDiasCredito', $nProcliDiasCredito);
            $pro->__SET('nODPais_Id', $nODPais_Id);
            $pro->__SET('nODIdioma_Id', $nODIdioma_Id);
            $pro->__SET('nProcliDepId', $nProcliDepId);
            $pro->__SET('nProcliDepName', $nProcliDepName);
            $pro->__SET('nProcliProvId', $nProcliProvId);
            $pro->__SET('nProcliProvName', $nProcliProvName);
            $pro->__SET('nProcliDistId', $nProcliDistId);
            $pro->__SET('nProcliDistName', $nProcliDistName);
            $pro->__SET('nODEstado', 1);
            $pro->__SET('nODEliminado', 0);
            $pro->__SET('nODUsuario_Id', 1);

            //Validar email
            if (!empty($_POST['cliente_correo'])) {
                $emailInDB = $this->origendestino_model->getByEmail($_POST['cliente_correo']);

                if (count($emailInDB) > 0) {
                    $this->printRes(false, sprintf('El email "%s" ya se encuentra registrado.', $email));
                }
            }

            return $this->origendestino_model->Crear($pro);
        }
    }

    function sayHello()
    {
        $data = array(
            'build' => filemtime(__FILE__)
        );
        $this->printRes(true, 'FMSAC API', $data, true);
    }
    function invokeError()
    {
        $this->printRes(false, 'The requested query not exist.');
    }

    private function requirePOST()
    {
        if (empty($_POST)) {
            $_POST = json_decode(file_get_contents('php://input'), true);
        }
        if (empty($_POST)) {
            $this->printRes(false, 'Se requiere uso de POST.');
        }
    }

    private function printRes($success, $message, $data = null, $merge = false)
    {
        $domain = !empty($_SERVER['HTTP_ORIGIN']) ? $_SERVER['HTTP_ORIGIN'] : '*';
        header('Content-type: application/json');
        header('Access-Control-Allow-Methods: GET, POST, OPTIONS, DELETE, PUT, PATCH');
        #header('Access-Control-Allow-Origin: *');
        header("Access-Control-Allow-Credentials: true");
        header("Access-Control-Allow-Origin: $domain");
        $res = array(
            'success' => $success,
            'message' => $message
        );
        if ($success) {
            if ($merge) {
                $res = array_merge($res, $data);
            } else {
                $res['data'] = $data;
            }
        }
        if (!$success) {
            http_response_code(400);
        }
        die(json_encode($res));
    }
}
