<?php
class CodigoModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL cod_listar(0)');
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cod = new Codigo();
                $cod->__set('Codigo_Id', $r->Codigo_Id);
				$cod->__set('sCodCodigo', $r->sCodCodigo);
				$cod->__set('nCodFamilia_Id', $r->nCodFamilia_Id);
				$cod->__set('sCodLatitud', $r->sCodLatitud);
				$cod->__set('sCodLongitud', $r->sCodLongitud);
				$cod->__set('nCodEstado', $r->nCodEstado);
				$cod->__set('nCodEliminado', $r->nCodEliminado);
				$cod->__set('dCodFecha_Act', $r->dCodFecha_Act);
				$cod->__set('Usuario_Id', $r->Usuario_Id);
				$cod->__set('Familia', $r->Familia);
                $result[] = $cod;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL cod_date(?,?)");
            $stm->execute([date('Y-m-d', strtotime($fechaInicio)),date('Y-m-d', strtotime($fechaFin))]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cod = new Codigo();
                $cod->__set('Codigo_Id', $r->Codigo_Id);
				$cod->__set('sCodCodigo', $r->sCodCodigo);
				$cod->__set('nCodFamilia_Id', $r->nCodFamilia_Id);
				$cod->__set('sCodLatitud', $r->sCodLatitud);
				$cod->__set('sCodLongitud', $r->sCodLongitud);
				$cod->__set('nCodEstado', $r->nCodEstado);
				$cod->__set('nCodEliminado', $r->nCodEliminado);
				$cod->__set('dCodFecha_Act', $r->dCodFecha_Act);
				$cod->__set('Usuario_Id', $r->Usuario_Id);
				$cod->__set('Familia', $r->Familia);
                $result[] = $cod;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
  
    public function Buscar($Codigo_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL cod_listar(?)');
            $stm->execute([$Codigo_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $cod = new Codigo();
                $cod->__set('Codigo_Id', $r->Codigo_Id);
				$cod->__set('sCodCodigo', $r->sCodCodigo);
				$cod->__set('nCodFamilia_Id', $r->nCodFamilia_Id);
				$cod->__set('sCodLatitud', $r->sCodLatitud);
				$cod->__set('sCodLongitud', $r->sCodLongitud);
				$cod->__set('nCodEstado', $r->nCodEstado);
				$cod->__set('nCodEliminado', $r->nCodEliminado);
				$cod->__set('dCodFecha_Act', $r->dCodFecha_Act);
				$cod->__set('Usuario_Id', $r->Usuario_Id);
				$cod->__set('Familia', $r->Familia);
                $result[] = $cod;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    
  
    public function BuscarPorCodigo($codigo)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL cod_buscarByCodigo(?)');
            $stm->execute([$codigo]);

            if($stm->rowCount()){
                return $stm->fetchObject(/* 'Codigo' */);
            }
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function Crear(Codigo $data)
    {
        try {
            $Codigo_Id = 0;
            $stm = $this->pdo->prepare('CALL cod_crear(?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('sCodCodigo'), 
				$data->__get('nCodFamilia_Id'), 
				$data->__get('sCodLatitud'), 
				$data->__get('sCodLongitud'), 
				$data->__get('nCodEstado'), 
				$data->__get('nCodEliminado'), 
				$_SESSION['usu_codigo']
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Codigo_Id = $r->Codigo_Id;
            }
            return $Codigo_Id;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Editar(Codigo $data)
    {
        try {
            $stm = $this->pdo->prepare('CALL cod_editar(?,?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('Codigo_Id'), 
				$data->__get('sCodCodigo'), 
				$data->__get('nCodFamilia_Id'), 
				$data->__get('sCodLatitud'), 
				$data->__get('sCodLongitud'), 
				$data->__get('nCodEstado'), 
				$data->__get('nCodEliminado'), 
				$_SESSION['usu_codigo']
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Eliminar($Codigo_Id)
    {
        try {
            $stm = $this->pdo->prepare('CALL cod_eliminar(?)');
            $stm->execute([$Codigo_Id]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
}
?>