<?php
class GrupoHectareaModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL gh_listar(0)');
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $gh = new GrupoHectarea();
                $gh->__set('GrupoHectarea_Id', $r->GrupoHectarea_Id);
				$gh->__set('nGHZona_Id', $r->nGHZona_Id);
				$gh->__set('sGHCodigo', $r->sGHCodigo);
				$gh->__set('nGHTamano', $r->nGHTamano);
				$gh->__set('nGHEstado', $r->nGHEstado);
				$gh->__set('nGHEliminado', $r->nGHEliminado);
				$gh->__set('dGHFecha_Act', $r->dGHFecha_Act);
				$gh->__set('Usuario_Id', $r->Usuario_Id);
				$gh->__set('Zona', $r->Zona);
                $result[] = $gh;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL gh_date(?,?)");
            $stm->execute([date('Y-m-d', strtotime($fechaInicio)),date('Y-m-d', strtotime($fechaFin))]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $gh = new GrupoHectarea();
                $gh->__set('GrupoHectarea_Id', $r->GrupoHectarea_Id);
				$gh->__set('nGHZona_Id', $r->nGHZona_Id);
				$gh->__set('sGHCodigo', $r->sGHCodigo);
				$gh->__set('nGHTamano', $r->nGHTamano);
				$gh->__set('nGHEstado', $r->nGHEstado);
				$gh->__set('nGHEliminado', $r->nGHEliminado);
				$gh->__set('dGHFecha_Act', $r->dGHFecha_Act);
				$gh->__set('Usuario_Id', $r->Usuario_Id);
                $result[] = $gh;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
  
    public function Buscar($GrupoHectarea_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL gh_listar(?)');
            $stm->execute([$GrupoHectarea_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $gh = new GrupoHectarea();
                $gh->__set('GrupoHectarea_Id', $r->GrupoHectarea_Id);
				$gh->__set('nGHZona_Id', $r->nGHZona_Id);
				$gh->__set('sGHCodigo', $r->sGHCodigo);
				$gh->__set('nGHTamano', $r->nGHTamano);
				$gh->__set('nGHEstado', $r->nGHEstado);
				$gh->__set('nGHEliminado', $r->nGHEliminado);
				$gh->__set('dGHFecha_Act', $r->dGHFecha_Act);
				$gh->__set('Usuario_Id', $r->Usuario_Id);
				$gh->__set('Zona', $r->Zona);
                $result[] = $gh;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function BuscarPorCodigo($sGHCodigo)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL gh_buscarByCodigo(?)');
            $stm->execute([$sGHCodigo]);
            if($stm->rowCount()){
                return $stm->fetchObject();
            }
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function Crear(GrupoHectarea $data)
    {
        try {
            $GrupoHectarea_Id = 0;
            $stm = $this->pdo->prepare('CALL gh_crear(?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('nGHZona_Id'), 
				$data->__get('sGHCodigo'), 
				$data->__get('nGHTamano'), 
				$data->__get('nGHEstado'), 
				$data->__get('nGHEliminado'), 
				$_SESSION['usu_codigo']
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $GrupoHectarea_Id = $r->GrupoHectarea_Id;
            }
            return $GrupoHectarea_Id;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Editar(GrupoHectarea $data)
    {
        try {
            $stm = $this->pdo->prepare('CALL gh_editar(?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('GrupoHectarea_Id'), 
				$data->__get('nGHZona_Id'), 
				$data->__get('sGHCodigo'), 
				$data->__get('nGHTamano'), 
				$data->__get('nGHEstado'), 
				$data->__get('nGHEliminado'), 
				$_SESSION['usu_codigo']
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Eliminar($GrupoHectarea_Id)
    {
        try {
            $stm = $this->pdo->prepare('CALL gh_eliminar(?)');
            $stm->execute([$GrupoHectarea_Id]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
}
?>