<?php
class NotacreditoModel extends DataBase
{
    private $conexion;
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            $this->conexion = $this->cnn();
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL not_list()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Not_listardate($fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL not_listdate('" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Buscar($notacredito_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL not_buscar($notacredito_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function save($Movimiento_Id, $Documento_Id, $nCReCodigoSunat, $nCReDescripcionSunat, $dNotcreFecha)
    {
        try {
            $Notacredito_Id = 0;
            $stm = $this->pdo->prepare("CALL not_crear(?,?,?,?,?, @Notacredito_Id)");
            $stm->execute(array(
                $Movimiento_Id,
                $Documento_Id,
                $nCReCodigoSunat,
                $nCReDescripcionSunat,
                date(
                    'Y-m-d',
                    strtotime($dNotcreFecha)
                )
            ));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Notacredito_Id = $r->Notacredito_Id;
            }
            return $Notacredito_Id;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Update($id, $data)
    {
        $this->conexion->where('Notacredito_Id', $id);
        $this->conexion->update('notacredito', $data);
    }

    public function updaeteEstado($movimiento_Id, $estado)
    {
        try {
            $stm = $this->pdo->prepare("update notacredito set `nNotEstadoSunat` = ? where Notacredito_Id = ?");
            $stm->execute([$estado, $movimiento_Id]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function categorias()
    {
        try {
            $categorias = [];
            $stm = $this->pdo->prepare("SELECT * FROM categoriareclamo");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $categorias[] = $r;
            }
            return $categorias;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

     public function Devolver($Movimiento_Id, $Usuario_Id, $sNotDocumento_Id, $sNotDocumento)
    {
        try {
            $stm = $this->pdo->prepare("CALL Mov_devolver(?,?,?,?)");
            $stm->execute([
                $Movimiento_Id,
                $Usuario_Id,
                $sNotDocumento_Id,
                $sNotDocumento
            ]);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
