<?php 

class ReportesModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function StockValidado()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Alm_StockValidado(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Usuario();
                $usu->__SET('valor01', $r->Codigo);
                $usu->__SET('valor03', $r->ProductoServicio);
                $usu->__SET('valor04', $r->Stock);
                $usu->__SET('valor05', $r->Unidad);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Stock()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Alm_StockConsolidado(0)");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $rep = new Reporte();
                $rep->__SET('valor01', $r->Codigo);
                $rep->__SET('valor02', $r->Codigo2);
                $rep->__SET('valor03', $r->CodigoOriginal);
                $rep->__SET('valor04', $r->Familia);
                $rep->__SET('valor05', $r->ProductoServicio);
                $rep->__SET('valor06', $r->Stock);
                $rep->__SET('valor07', $r->Unidad);
                $rep->__SET('valor08', $r->PrecioProm);
                $rep->__SET('valor09', $r->ValorizadoProm);
                $rep->__SET('valor10', $r->PrecioPromIGV);
                $rep->__SET('valor11', $r->Precioventa);
                $result[] = $rep;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Kardex($ProdServ_Id, $fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Kardex($ProdServ_Id,'" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Reporte();
                $usu->__SET('valor01', $r->FechaHora);
                $usu->__SET('valor02', $r->TipoMovimiento);
                $usu->__SET('valor03', $r->Almacen);
                $usu->__SET('valor04', $r->Documento);
                $usu->__SET('valor05', $r->FechaDoc);
                $usu->__SET('valor06', $r->OrigenDestino);
                $usu->__SET('valor07', $r->Estado);
                $usu->__SET('valor08', $r->Lote);
                $usu->__SET('valor09', $r->Cant);
                $usu->__SET('valor10', $r->Und);
                $usu->__SET('valor11', $r->SAntLote);
                $usu->__SET('valor12', $r->SPosLote);
                $usu->__SET('valor13', $r->SAnterior);
                $usu->__SET('valor14', $r->SPosterior);
                $usu->__SET('valor15', $r->Cant_Id);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    

  public function Reporte_Tiempos($fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Tiempos('" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Reporte();
          
                $usu->__SET('valor01', $r->Fecha);
                $usu->__SET('valor02', $r->Documento);
                $usu->__SET('valor03', $r->Cliente);
                $usu->__SET('valor04', $r->Observacion);
                $usu->__SET('valor05', $r->Inicio);
                $usu->__SET('valor06', $r->Termino);
                $usu->__SET('valor07', $r->Tiempo);
                $usu->__SET('valor08', $r->Servicio);
                $usu->__SET('valor09', $r->Plastico);
                $usu->__SET('valor10', $r->Cuerda);
                $usu->__SET('valor11', $r->Malla);
                $usu->__SET('valor12', $r->Carpa);
                $usu->__SET('valor13', $r->Observaciones);
                $usu->__SET('valor14', $r->DNI_Conductor);
                $usu->__SET('valor15', $r->Conductor);
                $usu->__SET('valor16', $r->Tiemposervicio_Id);
                $usu->__SET('valor17', $r->nTieEstado);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    
    
    public function VentaDetallada($fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaDetallada('" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Reporte();
                $usu->__SET('valor01', $r->Fecha);
                $usu->__SET('valor02', $r->Almacén);
                $usu->__SET('valor03', $r->Documento);
                $usu->__SET('valor04', $r->Condición);
                $usu->__SET('valor05', $r->Cliente);
                $usu->__SET('valor06', $r->Producto);
                $usu->__SET('valor07', $r->Cantidad);
                $usu->__SET('valor08', $r->Unidad);
                $usu->__SET('valor09', $r->PCostoUpuntoSIGV);
                $usu->__SET('valor10', $r->PVentaUpuntoSIGV);
                $usu->__SET('valor11', $r->Moneda);
                $usu->__SET('valor12', $r->Moneda_Id);
                $usu->__SET('valor13', $r->ImporteVenta);
                $usu->__SET('valor14', $r->Utilidad);
                $usu->__SET('valor15', $r->PorcRentabilidad);
                $usu->__SET('valor16', $r->TipoMov);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function catalogoProductos()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_CatalogoProductos()");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Reporte();
                $usu->__SET('valor01', $r->ProdServ_Id);
                $usu->__SET('valor02', $r->Codigo);
                $usu->__SET('valor03', $r->Codigo2);
                $usu->__SET('valor04', $r->CodigoOriginal);
                $usu->__SET('valor05', $r->Familia);
                $usu->__SET('valor06', $r->ProductoServicio);
                $usu->__SET('valor07', $r->sProSrvMarca);
                $usu->__SET('valor08', $r->sProSrvMarcaOriginal);
                $usu->__SET('valor09', $r->Stock);
                $usu->__SET('valor10', $r->Unidad);
                $usu->__SET('valor11', $r->PrecioPromIGV);
                $usu->__SET('valor12', $r->Precioventa);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function ventaxfacturacion($usu_code, $fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaTurno(?, ?, ?)");
            $stm->execute([
                $usu_code,
                (new DateTime($fechaIni))->format('Y-m-d H:i:s'),
                (new DateTime($fechaFin))->format('Y-m-d H:i:s')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
     public function ventaxvendedor($usu_code,$fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaxVendedor(?,?,?)");
            $stm->execute([
                $usu_code,
                (new DateTime($fechaIni))->format('Y-m-d H:i:s'),
                (new DateTime($fechaFin))->format('Y-m-d H:i:s')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function movimientos($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rep_movimiento(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function MovimientosSimple($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Movimiento(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function movimientosSunat($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_MovimientosSunat(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
     public function RegVentas($fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL reg_ventas(?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function RegVentasCeramicorp($fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rpt_ventasceramicorp(?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function LibrosElectronicos($fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rpt_libroselectronicos(?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
     public function MovimientosVendedor($fechaIni, $fechaFin, $tipomovimiento_id, $usu_code)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Movimiento_Vendedor(?, ?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id,
                $usu_code
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function VentaDiaria($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaDiaria(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function VentaMensual($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaMensual(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function RankingProdServ($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_RankingProdServ(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function RankingOD($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_RankingOD(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Creditos($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Creditos(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Pagos($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Pagos(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function StockVencimiento()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Vencimiento()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Stockmin()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rpt_stockmin()");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
      public function VentasxCliente($OrigenDestino_Id, $fechainicio, $fechafin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_Ventaxcliente($OrigenDestino_Id,'" . date('Y-m-d', strtotime($fechainicio)) . "','" . date('Y-m-d', strtotime($fechafin)) . "')");
            $stm->execute();

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $usu = new Reporte();
                $usu->__SET('valor01', $r->Fecha);
                $usu->__SET('valor02', $r->Hora);
                $usu->__SET('valor03', $r->Documento);
                $usu->__SET('valor04', $r->RUC);
                $usu->__SET('valor05', $r->CliProv);
                $usu->__SET('valor06', $r->Ubigeo);
                $usu->__SET('valor07', $r->TipoPago);
                $usu->__SET('valor08', $r->Moneda);
                $usu->__SET('valor09', $r->Importe);
                $usu->__SET('valor10', $r->IGV);
                $usu->__SET('valor11', $r->Total);
                $usu->__SET('valor12', $r->Estado);
                $usu->__SET('valor13', $r->EstadoSunat);
                $result[] = $usu;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function MovimientosYPagos($fechaIni, $fechaFin, $tipomovimiento_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_MovimientosYPagos(?, ?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d'),
                $tipomovimiento_id
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function VentaMensualPagadosyPendientes($fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL RPT_VentaMensual_Pagadas_PendientePago(?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ControlReparto($fechaIni, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rpt_controlreparto(?, ?)");
            $stm->execute([
                (new DateTime($fechaIni))->format('Y-m-d'),
                (new DateTime($fechaFin))->format('Y-m-d')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

}