<?php
class StockMinimoModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Precio($ProdServ_Id, $UnidadMedida_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pre_obtenerprecio($ProdServ_Id,$UnidadMedida_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pre = new Precioventa();
                $pre->__SET('PrecioVenta_Id', $r->PrecioVenta_Id);
                $pre->__SET('ProdServ_Id', $r->ProdServ_Id);
                $pre->__SET('sProSrvNombre', $r->sProSrvNombre);
                $pre->__SET('UnidadMedida_Id', $r->UnidadMedida_Id);
                $pre->__SET('Moneda_Id', $r->Moneda_Id);
                $pre->__SET('sUndDescripcion', $r->sUndDescripcion);
                $pre->__SET('PreVenPrecio', $r->PreVenPrecio);
                $pre->__SET('dPreVenFechaAct', $r->dPreVenFechaAct);
                $pre->__SET('nPreVenEliminado', $r->nPreVenEliminado);
                $pre->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $pre;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Listar($codigo)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL pre_listar($codigo,0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $pre = new Precioventa();
                $pre->__SET('PrecioVenta_Id', $r->PrecioVenta_Id);
                $pre->__SET('ProdServ_Id', $r->ProdServ_Id);
                $pre->__SET('sProSrvNombre', $r->sProSrvNombre);
                $pre->__SET('UnidadMedida_Id', $r->UnidadMedida_Id);
                $pre->__SET('Moneda_Id', $r->Moneda_Id);
                $pre->__SET('sUndDescripcion', $r->sUndDescripcion);
                $pre->__SET('PreVenPrecio', $r->PreVenPrecio);
                $pre->__SET('dPreVenFechaAct', $r->dPreVenFechaAct);
                $pre->__SET('nPreVenEliminado', $r->nPreVenEliminado);
                $pre->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $pre;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    // public function Buscar()
    // {
    //     try {
    //         $result = array();
    //         $stm = $this->pdo->prepare("CALL stockmin_listar(7)");
    //         $stm->execute();
    //         foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
    //             $pre = new StockMinimo();
    //             $pre->__SET('stock_minimo_id', $r->stock_minimo_id);
    //             $pre->__SET('ProdServ_Id', $r->ProdServ_Id);
    //             $pre->__SET('Almacen_Id', $r->Almacen_Id);
    //             $pre->__SET('nStockMinCantidad', $r->nStockMinCantidad);
    //             $pre->__SET('sStockMinUbicacion', $r->sStockMinUbicacion);
    //             $pre->__SET('nStockMinUsuario_Id', $r->nStockMinUsuario_Id);
    //             $pre->__SET('dStockMinFecha_Act', $r->dStockMinFecha_Act);
    //         }
    //         return $result;
    //     } catch (Exception $e) {
    //         echo die($e->getMessage());
    //     }
    // }

    public function Buscar($ProdServ_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT sm.*,a.sAlmNombre FROM stock_minimo sm
            inner join almacen a on (sm.Almacen_Id=a.Almacen_Id)
            where ProdServ_Id= ?");
            $stm->execute([$ProdServ_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }

            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Crear(StockMinimo $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL stockmin_crear(?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('ProdServ_Id'),
                $data->__get('Almacen_Id'),
                $data->__get('nStockMinCantidad'),
                $data->__get('sStockMinUbicacion'),
                $data->__get('nStockMinUsuario_Id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Éxito, los datos fueron registrados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Productos&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Editar(StockMinimo $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL stockmin_editar(?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('stock_minimo_id'),
                $data->__get('ProdServ_Id'),
                $data->__get('Almacen_Id'),
                $data->__get('nStockMinCantidad'),
                $data->__get('sStockMinUbicacion'),
                $data->__get('nStockMinUsuario_Id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';
            // echo '<script type="text/javascript">window.location="?c=Productos&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
    public function Eliminar(Precioventa $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL pre_eliminar(?)");
            $stm->execute(array($data->__get('PrecioVenta_Id')));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información Eliminada</strong>, los datos fueron eliminados correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function PrecioVenta($ProdServ_Id, $Moneda_Id, $UnidadMedida_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL prosrv_precioventa($ProdServ_Id, $Moneda_Id, $UnidadMedida_Id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r->PreVenPrecio;
            }
            return $result[0];
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }
}
