<?php

class TiemposervicioModel
{

    private $pdo;

    function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarPersonal($Tiemposervicio_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tie_listarpersonal('$Tiemposervicio_Id')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r->Personal_Id;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getTraceAsString();
        }
    }

    public function NombreCliente($Movimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tie_obtenercliente('$Movimiento_Id')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r->sODNombre;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getTraceAsString();
        }
    }

    public function Buscar($Movimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tie_listar(?)");
            $stm->execute([$Movimiento_Id]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $tie = new Tiemposervicio();
                $tie->__SET('Tiemposervicio_Id', $r->Tiemposervicio_Id);
                $tie->__SET('dTieHoraInicio', $r->dTieHoraInicio);
                $tie->__SET('dTieHoraFin', $r->dTieHoraFin);
                $tie->__SET('dTieDiferencia', $r->dTieDiferencia);
                $tie->__SET('nTieTipoServicio', $r->nTieTipoServicio);
                $tie->__SET('Movimiento_Id', $Movimiento_Id);
                $tie->__SET('sTieMaterial1', $r->sTieMaterial1);
                $tie->__SET('sTieMaterial2', $r->sTieMaterial2);
                $tie->__SET('sTieMaterial3', $r->sTieMaterial3);
                $tie->__SET('sTieMaterial4', $r->sTieMaterial4);
                $tie->__SET('sTieFirma', $r->sTieFirma);
                $tie->__SET('nTieEstadoMateriales', $r->nTieEstadoMateriales);
                $tie->__SET('nTieObservacion', $r->nTieObservacion);
                $tie->__SET('nTieEstado', $r->nTieEstado);
                $tie->__SET('tiemposervicioconductor_id', $r->tiemposervicioconductor_id);
                //$datemovimiento = new DateTime($r->dMovFecha);
                //$tie->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $tie;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarTiempoServicio($fechaInicio, $fechaFin, $TipoMovimiento_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL tie_date('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "', " . $TipoMovimiento_Id . ")");
            $stm->execute();
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $tie = new Tiemposervicio();
                $tie->__SET('Movimiento_Id', $r->Movimiento_Id);
                $tie->__SET('sMovObservacion', $r->sMovObservacion);
                $tie->__SET('dMovFecha', date('d-m-Y', strtotime($r->dMovFecha)));
                $tie->__SET('nMovTipoMovimiento_Id', $r->nMovTipoMovimiento_Id);
                $tie->__SET('sTMovNombre', $r->sTMovNombre);
                $tie->__SET('nMovTipopago', $r->nMovTipopago);
                $tie->__SET('Almacen_Id', $r->Almacen_Id);
                $tie->__SET('nMovTipoOrigenDestino', $r->nMovTipoOrigenDestino);
                $tie->__SET('nMovOrigenDestino_Id', $r->nMovOrigenDestino_Id);
                $tie->__SET('sODNombreComercial', $r->sODNombreComercial);
                $tie->__SET('sAlmNombre', $r->sAlmNombre);
                $tie->__SET('nMovTipodestino', $r->nMovTipodestino);
                $tie->__SET('Documento_Id', $r->Documento_Id);
                $tie->__SET('sDocNombre', $r->sDocNombre);
                $tie->__SET('sDocNombreCorto', $r->sDocNombreCorto);
                $tie->__SET('nDocTipoImprimir', $r->nDocTipoImprimir);
                $tie->__SET('sMovDocumento', $r->sMovDocumento);
                $tie->__SET('sMovDocReferencia', $r->sMovDocReferencia);
                $tie->__SET('Moneda_Id', $r->Moneda_Id);
                $tie->__SET('nMovTipoCambio', $r->nMovTipoCambio);
                $tie->__SET('nMovImporte', $r->nMovImporte);
                $tie->__SET('nMovIGV', $r->nMovIGV);
                $tie->__SET('nMovTotal', $r->nMovTotal);
                $tie->__SET('nMovSaldo', $r->nMovTotal);
                $tie->__SET('nMovTotalCancelado', $r->nMovTotalCancelado);
                $tie->__SET('dMovDetraccion', $r->dMovDetraccion);
                $tie->__SET('dMovPercepcion', $r->dMovPercepcion);
                $tie->__SET('dMovRetencion', $r->dMovRetencion);
                $tie->__SET('nMovEstadoSunat', $r->nMovEstadoSunat);
                $tie->__SET('nMovEstado', $r->nMovEstado);
                $tie->__SET('nMovEliminado', $r->nMovEliminado);
                $tie->__SET('dMovFecha_Act', $r->dMovFecha_Act);
                $tie->__SET('Usuario_Id', $r->Usuario_Id);
                $tie->__SET('Documento', $r->Documento);
                // ---------- AQUI INICIA LA TABLA TIEMPOSERVICIO
                $tie->__SET('Tiemposervicio_Id', $r->Tiemposervicio_Id);
                $tie->__SET('dTieHoraInicio', $r->Inicio);
                $tie->__SET('dTieHoraFin', $r->Fin);
                $tie->__SET('dTieDiferencia', $r->Diferencia);
                $tie->__SET('nTieTipoServicio', $r->TipoServicio);

                $tie->__SET('sTieMaterial1', $r->sTieMaterial1);
                $tie->__SET('sTieMaterial2', $r->sTieMaterial2);
                $tie->__SET('sTieMaterial3', $r->sTieMaterial3);
                $tie->__SET('sTieMaterial4', $r->sTieMaterial4);
                $tie->__SET('nTieObservacion', $r->nTieObservacion);
                $tie->__SET('sTieFirma', $r->sTieFirma);
                $tie->__SET('nTieEstado', $r->nTieEstado);
                $datemovimiento = new DateTime($r->dMovFecha);
                $tie->__SET('cantidaddias', $datecurrent->diff($datemovimiento)->days);
                $result[] = $tie;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function GuardarTiempoServicio()
    {
        try {
            $result = array();

            $hora_inicio = DateTime::createFromFormat('d-m-Y H:i', $_POST['hi']);
            $hora_fin = DateTime::createFromFormat('d-m-Y H:i', $_POST['hf']);
            $m1 = 0;
            $m2 = 0;
            $m3 = 0;
            $m4 = 0;
            $em1= 0;

            $tiposervicio = (($_POST['ts'] == 'S') ? 0 : 1);

            $materiales = json_decode($_POST['materiales']);
            $personal = json_decode($_POST['personal']);

            foreach ($materiales as $value) {
                switch ($value->Material) {
                    case 'P':
                        $m1 = 1;
                        break;
                    case 'CU':
                        $m2 = 1;
                        break;
                    case 'M':
                        $m3 = 1;
                        break;
                    case 'CA':
                        $m4 = 1;
                        break;

                    default:
                        break;
                }
            }

            $estadomaterial = json_decode($_POST['estadomaterial']);

            foreach ($estadomaterial as $value) {
                switch ($value->Estadomaterial) {
                    case 'B':
                        $em1 = 1;
                        break;
                    case 'M':
                        $em1 = 2;
                        break;
                    default:
                        break;
                }
            }

            $tiemposervicioconductor_id = 0;
            $sttm = $this->pdo->prepare('CALL tie_obtenerconductor(?,?)');
            $params_sttm = array($_POST['dni_conductor'], $_POST['nombre_conductor']);
            $sttm->execute($params_sttm);

            foreach ($sttm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $tiemposervicioconductor_id = $r->ID;
            }
            unset($sttm);

            $nombrefirma = ($_POST['nombrefirma'] == '0' ? 'firma-' . $hora_inicio->format('Y_m_d_H_i_s') . '.png' : $_POST['nombrefirma']);
            $Tiemposervicio_Id = ($_POST['Tiemposervicio_Id'] > 0) ? $_POST['Tiemposervicio_Id'] : '0';
            $stm = $this->pdo->prepare("CALL tie_registro(?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $arr_param = array(
                $Tiemposervicio_Id,
                $_POST['mid'],
                $hora_inicio->format('Y-m-d H:i:s'),
                $hora_fin->format('Y-m-d H:i:s'),
                $_POST['di'],
                $tiposervicio,
                $m1,
                $m2,
                $m3,
                $m4,
                (($_POST['nuevafirma'] == '1') ? $this->base64_to_bd($_POST['firma'], $nombrefirma) : $_POST['firma']),
                $em1,
                $_POST['obs'],
                $tiemposervicioconductor_id
            );
            $stm->execute($arr_param);
            unset($stm);

            if ($Tiemposervicio_Id != 0) {
                $stm2 = $this->pdo->prepare('CALL tie_resetpersonal(?)');
                $stm2_params = array($Tiemposervicio_Id);
                $stm2->execute($stm2_params);
                unset($stm2);
            }

            foreach ($personal as $value) {
                $stm3 = $this->pdo->prepare('CALL tie_registrarpersonal(?,?,?)');
                $stm3_params = array($_POST['mid'], $value->Personal, 1);
                $stm3->execute($stm3_params);
                unset($stm3);
            }
            echo '1';
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function base64_to_bd($data, $nombrearchivo)
    {
        //tiene que devolver la ruta, esta funcion guardar el fisico de la imagen
        //$name = time();
        $name = $nombrearchivo;
        $ruta = dirname(__FILE__) . '/../firmas/' . $_SESSION['usu_enterpriseRuc'] . '/';

        if (!is_dir($ruta)) {
            mkdir($ruta);
        }
        // $data = 'data:image/png;base64,AAAFBfj42Pj4';

        list($type, $data) = explode(';', $data);
        list(, $data) = explode(',', $data);
        $data = base64_decode($data);

        file_put_contents($ruta . $name, $data);

        //$data = base64_decode(preg_replace('#^data:image/\w+;base64,#i', '', $data64));
        //file_put_contents($ruta . $name . '.jpg', $data);
        return $name;
    }

    public function BuscarConductor($termino)
    {
        try {
            $result = array();
            $params = array($termino);

            $stm = $this->pdo->prepare("CALL tie_buscarconductor(?)");
            $stm->execute($params);

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getTraceAsString();
        }
    }

    public function BuscarConductorId($id)
    {
        try {
            $result = array();
            $params = array($id);
            $stm = $this->pdo->prepare('CALL tie_buscarconductorid(?)');
            $stm->execute($params);

            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getTraceAsString();
        }
    }

}
