<?php

class UbigeoModel {    
    private $pdo;
    public function __CONSTRUCT(){
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function getDepartamentos() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT id, dep, prov, dist, nombre 
                                        FROM ubigeo WHERE prov = '00'");
            $stm->execute();
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = (array) $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function getProvincias($dep) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT id, dep, prov, dist, nombre 
                                        FROM ubigeo WHERE dep = ? AND prov != '00' AND dist = '00'");
            $stm->execute([$dep]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = (array) $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function getDistritos($dep, $prov) {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT id, dep, prov, dist, nombre 
                                        FROM ubigeo WHERE dep = ? AND prov = ? AND dist != '00'");
            $stm->execute([$dep, $prov]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = (array) $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}