$(document).ready(function (d) {
    $('#s_dolares').html(sumatoria('s_dolares'));
    $('#s_soles').html(sumatoria('s_soles'));
    $('#s_tvs').html(sumatoria('s_tvs'));

    vistamensual_grafico();
    vistadiaria_grafico();
});

function pdfCall(pdfObject) {
    var number_of_pages = pdfObject.internal.getNumberOfPages()
    var pdf_pages = pdfObject.internal.pages;
    var myFooter = "Footer info";
    for (var i = 1; i < pdf_pages.length; i++) {
        // We are telling our pdfObject that we are now working on this page
        pdfObject.setPage(i);
        // The 10,200 value is only for A4 landscape. You need to define your own for other page sizes
        pdfObject.text(myFooter, 10, 200);
    }
}

function exportarPDF() {
    var element = document.getElementById('datos_reporte');

    // Replace all graph canvases with images
    //var graphCallback = replaceGraphs();
    $('#example1_length').hide();
    $('#example1_filter').hide();
    $('#example1_info').hide();
    $('.dataTables_paginate').hide();
    $('#titulo_pdf').show();


    html2pdf(element, {
        pdfCallback: pdfCall,
        margin: 10,
        filename: "REPORTE_HORMIGUITA.pdf",
        image: {type: 'jpeg', quality: 1},
        html2canvas: {dpi: 192, letterRendering: true},
        jsPDF: {unit: 'mm', format: 'a4', orientation: 'landscape'}
    });

    $('#example1_length').show();
    $('#example1_filter').show();
    $('#example1_info').show();
    $('.dataTables_paginate').show();
    $('#titulo_pdf').hide();
}

function vistadiaria_labels() {
    var cuantos = $('.count').length;
    var labels = [];
    for (var i = 0; i < cuantos; i++) {
        var dia = $($('.count')[i]).children()[0].innerHTML;
        labels.push(dia);
    }

    return labels;
}

function vistadiaria_datasets() {
    var cuantos = $('.count').length;
    var result = [];

//    var color_soles = generar_color_hex();
//    var color_dolares = generar_color_hex();
//    var color_valorizado = generar_color_hex();

    var data_soles = [];
    for (var i = 0; i < cuantos; i++) {
        data_soles.push($($('.count')[i]).children()[2].innerHTML);
    }

    var dataset_soles = {
        label: 'Soles',
        backgroundColor: '#1f34f0',
        borderColor: '#1f34f0',
        data: data_soles,
        fill: false
    };

    result.push(dataset_soles);

    var data_dolares = [];
    for (var j = 0; j < cuantos; j++) {
        data_dolares.push($($('.count')[j]).children()[1].innerHTML);
    }

    var dataset_dolares = {
        label: 'Dolares',
        backgroundColor: '#85bb65',
        borderColor: '#85bb65',
        data: data_dolares,
        fill: false
    };

    result.push(dataset_dolares);

    var data_valorizado = [];
    for (var k = 0; k < cuantos; k++) {
        data_valorizado.push($($('.count')[k]).children()[3].innerHTML);
    }

    var dataset_valorizado = {
        label: 'Total valorizado',
        backgroundColor: '#d1ffdc',
        borderColor: '#000000',
        data: data_valorizado,
        fill: true
    };

    result.push(dataset_valorizado);

    return result;
}

function vistadiaria_grafico() {
    if ($('#grafico_vistadiaria').length > 0) {
        var cuantos = $('.count').length;
        if (cuantos > 0) {
            $('#click-export-pdf').prop('disabled', false);
            var ctx = $('#grafico');

            var data = {labels: vistadiaria_labels(),
                datasets: vistadiaria_datasets()};

            var options = {
                responsive: true,
                title: {
                    display: true,
                    text: 'Relación de operaciones por día'
                },
                tooltips: {
                    mode: 'index',
                    intersect: false,
                },
                hover: {
                    mode: 'nearest',
                    intersect: true
                },
                scales: {
                    xAxes: [{
                            display: true,
                            scaleLabel: {
                                display: true,
                                labelString: 'Día'
                            }
                        }],
                    yAxes: [{
                            display: true,
                            scaleLabel: {
                                display: true,
                                labelString: 'Monto'
                            }
                        }]
                }
            };

            var grafico = new Chart(ctx, {
                type: 'line',
                data: data,
                options: options
            });
        } else {
            $('#click-export-pdf').prop('disabled', true);
            $('#grafico_vistadiaria').fadeOut('fast');
        }
    }
}

function sumatoria(sum) {
    var cantidad = $('td[sum="' + sum + '"]').length;
    var sumatoria = 0;
    for (var i = 0; i < cantidad; i++) {
        //console.log(sum, sumatoria);
        sumatoria = sumatoria + parseFloat($($('td[sum="' + sum + '"]')[i]).html());
    }

    return sumatoria.toFixed(2);
}

function vistamensual_labels() {
    var cuantos = $('.count').length;
    var labels = [];
    for (var i = 0; i < cuantos; i++) {
        var mes = $($('.count')[i]).children()[0].innerHTML + '-' + $($('.count')[i]).children()[1].innerHTML;
        labels.push(mes);
    }

    return labels;
}

function generar_color_hex() {
    var almohadilla = '#';
    var caracteres = '0123456789ABCDEF';
    var result = '';
    for (var i = 0; i < 6; i++) {
        result += caracteres.charAt(Math.floor(Math.random() * caracteres.length));
    }

    return almohadilla + result;
}

function vistamensual_datasets() {
    var cuantos = $('.count').length;
    var result = [];

    var color_soles = generar_color_hex();
    var color_dolares = generar_color_hex();
    var color_valorizado = generar_color_hex();

    var data_soles = [];
    for (var i = 0; i < cuantos; i++) {
        data_soles.push($($('.count')[i]).children()[3].innerHTML);
    }

    var dataset_soles = {
        label: 'Soles',
        backgroundColor: '#1f34f0',
        borderColor: '#1f34f0',
        data: data_soles,
        fill: false
    };

    result.push(dataset_soles);

    var data_dolares = [];
    for (var j = 0; j < cuantos; j++) {
        data_dolares.push($($('.count')[j]).children()[2].innerHTML);
    }

    var dataset_dolares = {
        label: 'Dolares',
        backgroundColor: '#85bb65',
        borderColor: '#85bb65',
        data: data_dolares,
        fill: false
    };

    result.push(dataset_dolares);

    var data_valorizado = [];
    for (var k = 0; k < cuantos; k++) {
        data_valorizado.push($($('.count')[k]).children()[4].innerHTML);
    }

    var dataset_valorizado = {
        label: 'Total valorizado',
        backgroundColor: '#d1ffdc',
        borderColor: '#000000',
        data: data_valorizado,
        fill: true
    };

    result.push(dataset_valorizado);

    return result;
}

function vistamensual_grafico() {
    if ($('#grafico_vistamensual').length > 0) {
        var cuantos = $('.count').length;
        if (cuantos > 0) {
            $('#click-export-pdf').prop('disabled', false);
            var ctx = $('#grafico');

            var data = {labels: vistamensual_labels(),
                datasets: vistamensual_datasets()};

            var options = {
                responsive: true,
                title: {
                    display: true,
                    text: 'Relación de operaciones por Mes'
                },
                tooltips: {
                    mode: 'index',
                    intersect: false,
                },
                hover: {
                    mode: 'nearest',
                    intersect: true
                },
                scales: {
                    xAxes: [{
                            display: true,
                            scaleLabel: {
                                display: true,
                                labelString: 'Mes'
                            }
                        }],
                    yAxes: [{
                            display: true,
                            scaleLabel: {
                                display: true,
                                labelString: 'Monto'
                            }
                        }]
                }
            };

            var grafico = new Chart(ctx, {
                type: 'line',
                data: data,
                options: options
            });
        } else {
            $('#click-export-pdf').prop('disabled', true);
            $('#grafico_vistamensual').fadeOut('fast');
        }
    }
}