(function ($) {
    $.validator.addMethod("letras", function (value, element) {
        return this.optional(element) || /^[a-záéóóúàèìòùäëïöüñ\s]+$/i.test(value);
    });
    $.validator.addMethod("decimales", function (value, element) {
        return this.optional(element) || /^([0-9]+\.+[0-9]|[0-9])+$/.test(value);
    });
    $.validator.addMethod("fecha", function (value, element) {
        return this.optional(element) || /^([0-9]{2}\/[0-9]{2}\/[0-9]{4})$/.test(value);
    });
    // $.validator.setDefaults({
    //     /*OBSERVATION: note how the ignore option is placed in here*/
    //     ignore: ':not(select:hidden, input:visible, textarea:visible)',

    //     /*...other options omitted to focus on the OP...*/

    //     errorPlacement: function (error, element) {
    //         if (element.hasClass('bs-select')) {
    //             error.insertAfter('.bootstrap-select');
    //         } else {
    //             error.insertAfter(element);
    //         }
    //         /*Add other (if...else...) conditions depending on your
    //         * validation styling requirements*/
    //     }
    // });

    $.fn.serializeAll = function () {
        var data = $(this).serializeArray();

        $(':disabled[name]', this).each(function () {
            data.push({ name: this.name, value: $(this).val() });
        });

        return data;
    };

    $.fn.validators = function (options) {
        var rules = {},
            messages = {};
        var msj = {
            required: 'El campo es requerido',
            minlength: 'Minimo de caracteres permitidos: {0}',
            maxlength: 'Máximo de caracteres permitidos: {0}',
            email: 'El email ingresado no es correcto.',
            number: 'Solo está permitido numeros.',
            equalTo: 'El campo tiene que ser el mismo',
            letras: 'solo letras.',
            decimales: 'solo decimales',
            fecha: 'fecha no valida.'
        };
        for (var key in options.rules) {
            var obj_msj = {};
            var item = options.rules[key];
            rules[key] = item;
            for (let key1 in item) {
                obj_msj[key1] = msj[key1].replace(/\{0\}/g, item[key1]);
            }
            messages[key] = obj_msj;
        }
        this.validate({
            // errorElement: "es",
            ignore: ':not(select:hidden, input:visible, textarea:visible)',
            validateHiddenInputs: true,
            validateOnEvent: true,
            rules: rules,
            messages: messages,
            errorPlacement: function (error, element) {
                // Add the `help-block` class to the error element
                error.addClass("help-block");
                // Add `has-feedback` class to the parent div.form-group
                // in order to add icons to inputs
                element.parents(".col-sm-5").addClass("has-feedback");
                if (element.prop("type") === "checkbox") {
                    error.insertAfter(element.parent("label"));
                } else {
                    error.insertAfter(element);
                } 
            },
            success: function (label, element) {
                // Add the span element, if doesn't exists, and apply the icon classes to it.
                // if (!$(element).next("span")[0]) {
                //     $("<span class='glyphicon glyphicon-ok form-control-feedback'></span>").insertAfter($(element));
                // }
            },
            highlight: function(element) {
                $(element).closest('.control-group')
                    .removeClass('success').addClass('error');
            },
            submitHandler: function(event) {
                return true;
            }
        });
    };
    $.fn.inputFormat = function (opt) {
        if (typeof opt == "string") {
            switch (opt) {
                case "value":
                    var val;
                    this.each(function () {
                        val = parseFloat(this.value.replace(new RegExp(this.ifconfig.miles, 'g'), ""));
                    });
                    return val;
                    break;
                case "format":
                    this.each(function () {
                        var val = parseFloat(this.value) + "";
                        if (val != undefined && val != null && val != "") {
                            var sep = val.split(this.ifconfig.decimales);
                            var enteros = sep[0].replace(new RegExp(this.ifconfig.miles, 'g'), "");
                            var decimales = "00";
                            if (sep[1]) {
                                decimales = sep[1].length == 1 ? sep[1] + "0" : sep[1];
                            }
                            var formateado = "";
                            var count = 0;
                            for (var i = enteros.length - 1; i >= 0; i--) {
                                if (count === 3) {
                                    formateado = enteros[i] + this.ifconfig.miles + formateado;
                                    count = 1;
                                } else {
                                    count++;
                                    formateado = enteros[i] + formateado;
                                }
                            }
                            if (val.indexOf(this.ifconfig.decimales) !== -1) {
                                formateado = formateado + this.ifconfig.decimales + decimales;
                            }
                        }
                        this.value = formateado;
                    });
                    break;
            }
            return this;
        } else {
            return this.each(function () {
                this.ifconfig = methods.extend(opt, optDefault);
                $(this).css({
                    "text-align": "left",
                });
                $(this).on("keypress", methods.format);
            });
        }
    };
    /**
     * Funcion general que importa el documentos excel
     * y devuelve la información en un arreglo de objectos
     */
    $.fn.importExcel = function (handler) {
        var element = this[0];
        if (element) {
            element.setAttribute("accept", ".xlsx, .xls, .csv");
            element.onchange = function () {
                var reader = new FileReader();
                reader.onload = function (e) {
                    var data = e.target.result;
                    var workbook = XLSX.read(data, {
                        type: 'binary'
                    });
                    var XL_row_object = XLSX.utils.sheet_to_row_object_array(workbook.Sheets[workbook.SheetNames[0]]);
                    handler(XL_row_object);
                };
                reader.onerror = function (ex) {
                    throw new Error("incorrect import file", ex);
                };
                reader.readAsBinaryString(this.files[0]);
            };
        } else {
            throw new Error("elemento no se encuentra o no esta definido.");
        }
    };
    /**
     * carga la data en una tabla definida
     */
    $.fn.loadDataInTable = function (data, options) {

        var defaultOptions = {
            auto_increment: false
        };

        options = $.extend(defaultOptions, options || {});

        var element = this[0];
        if (element) {
            var table = '';
            var tbody = element.querySelector('tbody');
            if (data.length > 0) {
                for (var index = 0; index < data.length; index++) {
                    var item = data[index];
                    table += `<tr>`;
                    if (options.auto_increment) {
                        table += `<td>${index + 1}</td>`;
                    }
                    for (var column in item) {
                        table += `<td>${item[column]}</td>`;
                    }
                    table += `</tr>`;
                }
            } else {
                var thead = element.querySelector('thead tr');
                var rows_count = thead.children
                table = `<tr><td colspan="${rows_count}"></td></tr>`;
            }
            tbody.innerHTML = table;
        } else {
            throw new Error("elemento no se encuentra o no esta definido.");
        }
    };
    var methods = {
        format: function (e) {
            var key = e.keyCode || e.which;
            var tecla = String.fromCharCode(key).toLowerCase();
            //            console.log(this.ifconfig);
            var letras = "0123456789" + this.ifconfig.decimales;
            var especiales = [8, 37, 39, 46];
            var cursor = this.selectionStart;
            var tecla_especial = false
            for (var i in especiales) {
                if (key == especiales[i]) {
                    tecla_especial = true;
                    break;
                }
            }
            if (this.selectionStart !== this.selectionEnd) {
                var numero = this.value.slice(0, this.selectionStart) + tecla + this.value.slice(this.selectionEnd);
            } else if (this.selectionStart === 0 && this.selectionEnd === this.value.length - 1) {
                this.value = "";
                var numero = tecla;
            } else {
                var numero = this.value.slice(0, cursor) + tecla + this.value.slice(cursor);
            }
            var sep = numero.split(this.ifconfig.decimales);
            var comas = methods.countComas(this.value, cursor, this.ifconfig.miles);
            var enteros = sep[0].replace(new RegExp(this.ifconfig.miles, 'g'), "");
            var decimales;
            if (numero.indexOf(this.ifconfig.decimales) !== -1) {
                var decimales = sep[1];
            }
            if (decimales) {
                if (decimales.length >= this.ifconfig.num_decimales + 1
                    && (this.selectionStart === this.selectionEnd && this.selectionStart >= this.value.length - decimales)) {
                    return false;
                }
            }
            if (letras.indexOf(tecla) === -1 && !tecla_especial || (this.value.indexOf(this.ifconfig.decimales) !== -1 && tecla == this.ifconfig.decimales))
                return false;
            var formateado = "";
            var count = 0;
            for (var i = enteros.length - 1; i >= 0; i--) {
                if (count === 3) {
                    formateado = enteros[i] + this.ifconfig.miles + formateado;
                    count = 1;
                } else {
                    count++;
                    formateado = enteros[i] + formateado;
                }
            }
            if (numero.indexOf(this.ifconfig.decimales) !== -1) {
                formateado = formateado + this.ifconfig.decimales + decimales;
            }
            comas = comas - methods.countComas(formateado, cursor, this.ifconfig.miles);
            cursor = cursor - comas;
            formateado = formateado.slice(0, cursor) + formateado.slice(cursor + 1);
            this.value = formateado;
            this.selectionEnd = cursor;
            this.selectionStart = cursor;
        },
        countComas: function (string, cursor, separador) {
            var c = 0;
            for (var i = 0; i <= cursor && i < string.length; i++) {
                if (separador == string[i]) {
                    c++;
                }
            }
            return c;
        },
        extend: function (toObj, fromObj) {
            toObj = toObj || {};
            Object.keys(fromObj).forEach(function (key) {
                if (!(key in toObj)) {
                    toObj[key] = fromObj[key];
                }
            });
            return toObj;
        }
    };
    var optDefault = {
        miles: ",",
        decimales: ".",
        num_decimales: 2
    };
}(jQuery));