<?php
require_once 'model/parametro.entidad.php';
require_once 'model/parametro.model.php'; 
require_once 'model/prodserv.entidad.php';
require_once 'model/prodserv.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/adopcion.entidad.php';
require_once 'model/adopcion.model.php';
require_once 'model/familiaarbol.entidad.php';
require_once 'model/familiaarbol.model.php';
require_once 'model/codigo.entidad.php';
require_once 'model/codigo.model.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/adopciondetalle.entidad.php';
require_once 'model/adopciondetalle.model.php';
require_once 'model/grupohectarea.entidad.php';
require_once 'model/grupohectarea.model.php';

class AdopcionController extends MetodosController
{
    public $url;
    //private $electronic_controller;
    private $seguridad;
    public $parametro_model;
    public $prodserv_model;
	public $origendestino_model;
	public $adopcion_model;
	public $familiaarbol_model;
	public $codigo_model;
	public $unidadmedida_model;
	public $adopciondetalle_model;
	public $grupohectarea_model;

    public function __CONSTRUCT()
    {
        $this->url = 'http://colibri-fm.ddns.net:8087/servicio/Transaccion/AnularSunat/' . $_SESSION['usu_enterpriseRuc'];
        $this->parametro_model = new ParametroModel();
        //$this->electronic_controller = new ElectronicController();
        $this->seguridad = new Seguridad();
        $this->prodserv_model = new ProdservModel();
		$this->origendestino_model = new OrigendestinoModel();
		$this->adopcion_model = new AdopcionModel();
		$this->familiaarbol_model = new FamiliaArbolModel();
		$this->codigo_model = new CodigoModel();
		$this->unidadmedida_model = new UnidadmedidaModel();
		$this->adopciondetalle_model = new AdopcionDetalleModel();
		$this->grupohectarea_model = new GrupoHectareaModel();

        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 10) {
                $this->ICBPER =  ($pa->__GET('sParValor')) / 100;
            }
            if ($pa->__GET('Parametro_Id') == 14) {
                $this->DECIMALES =  ($pa->__GET('sParValor'));
            }
        }
    }

    public function Index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $adopcion = $this->adopcion_model->ListarDate(
            isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
            isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y')))
        );
        require_once 'view/header.php';
        require_once 'view/webforms/wfaadopcion.php';
        if(isset($_POST['REFPROMOVER_Id'])){
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            PromoverREFPROMOVER({$_POST['REFPROMOVER_Id']})
                        });
                  </script>";
        }
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }


    public function FrmGuardarAdopcion()
    {
        $parametro = $this->parametro_model->ListarParametros();
		$clientes_print = $this->TipoPrvClienListarTipo(2,false);
		$productos = $this->prodserv_model->Listar();
        $familias = $this->familiaarbol_model->Listar();
		$codigos = $this->codigo_model->Listar();
		$grupohectareas = $this->grupohectarea_model->Listar();

        require_once 'view/webforms/wfaadopciona.php';
    }

    public function FrmEditarAdopcion()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $adopcion = $this->adopcion_model->Buscar($_POST['Adopcion_Id']);
		$clientes_print = $this->TipoPrvClienListarTipo(2,false);
		$productos = $this->prodserv_model->Listar();
        $familias = $this->familiaarbol_model->Listar();
		$codigos = $this->codigo_model->Listar();
		$grupohectareas = $this->grupohectarea_model->Listar();

        foreach ($adopcion as $r) :
            require_once 'view/webforms/wfaadopciona.php';
        endforeach;
    }

    public function PromoverAdopcion()
    {
        $promover_id = $_POST['Promover_Id'];
        $promover_controller = $_POST['Promover_Controller'];
        $promover_controller_Id = sprintf('n%s%s_Id',strtoupper('ado'),$promover_controller);

        $parametro = $this->parametro_model->ListarParametros();
        $data = eval(sprintf('return $this->%s_model->Buscar();',strtolower($promover_controller)));

        if(!empty($data)){
            $ado = new Adopcion();
            $ado->__set('Adopcion_Id', $data[0]->{$promover_controller_Id});
            /**
            * COMPLETAR LA LISTA DE DATOS
            */
            require_once 'view/webforms/wfaadopciona.php';
        }
    }

    public function MostrarAdopcion()
    {
        $ado = $this->adopcion_model->Buscar($_POST['Adopcion_Id']);
		
        echo '<table class="table table-hover table-bordered">';
        foreach ($ado as $r){

		$mostrar_arbol = $mostrar_hectarea = $mostrar_donacion = false;

		$tipo_adopcion = '';
		if ($r->__get('nAdoTipoAdopcion_Id') == '1') {
			$tipo_adopcion =  'Donación';
			$mostrar_donacion = true;
		}else if ($r->__get('nAdoTipoAdopcion_Id') == '2') {
			$tipo_adopcion =  'Donación árboles';
			$mostrar_arbol = true;
		}else if ($r->__get('nAdoTipoAdopcion_Id') == '3') {
			$tipo_adopcion =  'Donación hectáreas';
			$mostrar_hectarea = true;
		}else if ($r->__get('nAdoTipoAdopcion_Id') == '4') {
			$tipo_adopcion =  'Adopción árboles';
			$mostrar_arbol = true;
		}else if ($r->__get('nAdoTipoAdopcion_Id') == '5') {
			$tipo_adopcion =  'Adopción hectáreas';
			$mostrar_hectarea = true;
		}

		$estado = '';
		if ($r->__get('nAdoEstado') == '0') {
			$estado =  '<span class="label label-danger">Anulado</span>';
		}else if ($r->__get('nAdoEstado') == '1') {
			$estado =  '<span class="label label-success">Pagado</span>';
		}else if ($r->__get('nAdoEstado') == '2') {
			$estado =  '<span class="label label-warning">Pendiente de Pago</span>';
		}

		$metodo_pago = '';
		if ($r->__get('nAdoMetodoPago_Id') == '1') {
			$metodo_pago =  'Transferencia';
		}else if ($r->__get('nAdoMetodoPago_Id') == '2') {
			$metodo_pago =  'Paypal';
		}else if ($r->__get('nAdoMetodoPago_Id') == '3') {
			$metodo_pago =  'Canje de árboles por puntos';
		}else if ($r->__get('nAdoMetodoPago_Id') == '4') {
			$metodo_pago =  'Otros';
		}

		echo '<tr>';
		echo '<td>Fecha: </td>';
		echo '<td>' . $r->__get('dAdoFecha') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Cliente: </td>';
		echo '<td>' . $r->__get('Cliente') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Tipo adopción/donación: </td>';
		echo '<td>' . $tipo_adopcion . '</td>';
		echo '</tr>';
		if($mostrar_arbol){
		echo '<tr>';
		echo '<td>Motivo/Propósito: </td>';
		echo '<td>' . $r->__get('sAdoMotivo') . '</td>';
		echo '</tr>';
		}
		if($mostrar_arbol && $r->__GET('nAdoEsRegalo')!=0){
		echo '<tr>';
		echo '<td>¿Es regalo?: </td>';
		echo '<td>' . ($r->__GET('nAdoEsRegalo') == 1 ? 'SI' : 'NO') . '</td>';
		echo '</tr>';
		}
		echo '<tr>';
		echo '<td>Años: </td>';
		echo '<td>' . $r->__get('nAdoAnios') . '</td>';
		echo '</tr>';
		if($r->__GET('nAdoCodigo_Id')!=0){
		echo '<tr>';
		echo '<td>Árbol: </td>';
		echo '<td>' . $r->__get('Codigo') . '</td>';
		echo '</tr>';
		}
		if($r->__GET('nAdoGrupoHectarea_Id')!=0){
		echo '<tr>';
		echo '<td>Grupo de Hectáreas: </td>';
		echo '<td>' . $r->__get('GrupoHectarea') . '</td>';
		echo '</tr>';
		}
		/* echo '<tr>';
		echo '<td>Documento (FE): </td>';
		echo '<td>' . $r->__get('sAdoDocumentoFE') . '</td>';
		echo '</tr>'; */
		echo '<tr>';
		echo '<td>Precio: </td>';
		echo '<td>' . $r->__get('nAdoPrecio') . '</td>';
		echo '</tr>';
		/* echo '<tr>';
		echo '<td>Tipo moneda: </td>';
		echo '<td>' . ($r->__GET('nAdoTipoMoneda_Id') == 1 ? 'Soles' : 'Dólares') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Tipo de cambio: </td>';
		echo '<td>' . $r->__get('nAdoTipoCambio') . '</td>';
		echo '</tr>'; */
		echo '<tr>';
		echo '<td>Certificado: </td>';
		$cert = !empty($r->__get('sAdoCerificado'))?'<a href="'.$r->__get('sAdoCerificado').'" target="_blank">Ver certificado</a>':'-';
		echo '<td>' . $cert . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Método de pago: </td>';
		echo '<td>' . $metodo_pago . '</td>';
		echo '</tr>';
		if ($r->__get('nAdoMetodoPago_Id') == '2') {
		echo '<tr>';
		echo '<td>Paypal Token: </td>';
		echo '<td>' . $r->__get('sAdoPaypalToken') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Paypal Payer ID: </td>';
		echo '<td>' . $r->__get('sAdoPaypalPayerID') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Paypal Payment Id: </td>';
		echo '<td>' . $r->__get('sAdoPaypalPaymentID') . '</td>';
		echo '</tr>';
		}
		echo '<tr>';
		echo '<td>Fecha de Pago: </td>';
		echo '<td>' . $r->__get('dAdoFechaPago') . '</td>';
		echo '</tr>';
		echo '<tr>';
		echo '<td>Estado: </td>';
		echo '<td>' . $estado . '</td>';
		echo '</tr>';
			/* echo "<tr>";
            echo "<td colspan='2'>";
            echo "<table class='table table-hover table-bordered'>";
            echo "<thead>";
            echo "<tr>";
            echo "<th>Producto</th>";
            echo "<th>Cantidad</th>";
            echo "<th>Unidad</th>";
            echo "<th>Precio</th>";
            echo "<th>Sub Total</th>";
            echo "</tr>";
            echo "</thead>";
            echo "<tbody>";
            $detalle_adopion = $this->adopciondetalle_model->Buscar($r->__GET('Adopcion_Id'));
            foreach ($detalle_adopion as $detmov) :
                echo '<tr>';
                echo '<td>' . $this->ProdservdNombre($detmov->__GET('nAdoDetProdServ')) . '</td>';
                echo '<td>' . $detmov->__GET('nAdoDetCantidad') . '</td>';
                echo '<td>' . $this->UnidadNombre($detmov->__GET('nAdoDetUnidad_Id')) . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nAdoDetPrecioUnitario'), $this->DECIMALES, ".", ",") . '</td>';
                echo '<td style="text-align: right;">' . number_format($detmov->__GET('nAdoDetCantidad')*$detmov->__GET('nAdoDetPrecioUnitario'), $this->DECIMALES, ".", ",") . '</td>';
                echo '</tr>';
            endforeach;
            echo '<tr><td style="text-align: right;" colspan="4">IMPORTE</td><td style="text-align: right;">' . number_format($r->__GET('nAdoImporte'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="4">IGV</td><td style="text-align: right;">' . number_format($r->__GET('nAdoIGV'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '<tr><td style="text-align: right;" colspan="4">TOTAL</td><td style="text-align: right;">' . number_format($r->__GET('nAdoTotal'), $this->DECIMALES, ".", ",") . '</td></tr>';
            echo '</tbody>';
            echo '</table>';
            echo '</td>';
            echo '</tr>'; */
        }
        echo '</table>';
    }

	public function ObtnerPathImagen($post_param){
		$rnd = md5(mt_rand()*time());
		$fx = sprintf('./uploads/cert_%s.pdf',$rnd);
		if(preg_match('/^data/i',$post_param)){
			$encoded_image = explode(",", $post_param)[1];
			$decoded_image = base64_decode($encoded_image);
			file_put_contents($fx, $decoded_image);
		}else if(preg_match('/clear/i',$post_param) || $post_param==''){
			/* if(file_exists($fx)){
				unlink($fx);
			} */
			$fx = '';
		}else{
			$fx = $post_param;
		}
		return $fx;
	}

    public function GuardarAdopcion()
    {
        $is_edit = $_POST['Adopcion_Id']!=0?true:false;

		$sAdoCerificado = $this->ObtnerPathImagen($_POST['sAdoCerificado']);

        $ado = new Adopcion();
        if ($is_edit ? $ado->__SET('Adopcion_Id', $_POST['Adopcion_Id']) : '');
        $ado->__set('dAdoFecha', !empty($_POST['dAdoFecha'])?$_POST['dAdoFecha']:date('d-m-Y'));
		$ado->__set('nAdoCliente_Id', $_POST['nAdoCliente_Id']);
		$ado->__set('nAdoTipoAdopcion_Id', $_POST['nAdoTipoAdopcion_Id']);
		$ado->__set('sAdoMotivo', $_POST['sAdoMotivo']);
		$ado->__set('nAdoEsRegalo', $_POST['nAdoEsRegalo']);
		$ado->__set('nAdoCodigo_Id', $_POST['nAdoCodigo_Id']);
		$ado->__set('nAdoAnios', $_POST['nAdoAnios']);
		$ado->__set('nAdoGrupoHectarea_Id', $_POST['nAdoGrupoHectarea_Id']);
		$ado->__set('sAdoDocumentoFE', $_POST['sAdoDocumentoFE']);
		$ado->__set('nAdoPrecio', $_POST['nAdoPrecio']);
		$ado->__set('nAdoTipoMoneda_Id', $_POST['nAdoTipoMoneda_Id']);
		$ado->__set('nAdoTipoCambio', $_POST['nAdoTipoCambio']);
		$ado->__set('sAdoCerificado', $sAdoCerificado);
		$ado->__set('nAdoMetodoPago_Id', $_POST['nAdoMetodoPago_Id']);
		$ado->__set('sAdoPaypalToken', $_POST['sAdoPaypalToken']);
		$ado->__set('sAdoPaypalPayerID', $_POST['sAdoPaypalPayerID']);
		$ado->__set('sAdoPaypalPaymentID', $_POST['sAdoPaypalPaymentID']);
		$ado->__set('dAdoFechaPago', $_POST['dAdoFechaPago']);
		$ado->__set('nAdoEstado', 1);
		$ado->__set('nAdoEliminado', 0);
		$ado->__set('Usuario_Id', $_SESSION['usu_codigo']);
		//print_r($_POST['productos']);
		//return;
        if ($is_edit) {
			$Adopcion_Id = $_POST['Adopcion_Id'];
            $this->adopcion_model->Editar($ado);
        } else {
           	$Adopcion_Id = $this->adopcion_model->Crear($ado);
        }
		/* $productos = !empty($_POST['productos'])?$_POST['productos']:[];
		if(!empty($productos)){
			foreach($productos as $p){
				$ad = new AdopcionDetalle();
				$ad->__set('nAdoDetAdopcion_Id',$Adopcion_Id);
				$ad->__set('nAdoDetProdServ',$p['ProdServ_Id']);
				$ad->__set('nAdoDetAlmacen_Id',$p['Almacen_Id']);
				$ad->__set('nAdoDetUnidad_Id',$p['Unidadmedida_Id']);
				$ad->__set('nAdoDetCantidad',$p['Cantidad']);
				$ad->__set('nAdoDetPrecioUnitario',$p['PrecioUnitario']);
				$ad->__set('nAdoDetIncluyeIGV',$p['IncluyeIGV']);
				$ad->__set('nAdoDetExoneradoIGV',$p['ExoneradoIGV']);
				$ad->__set('nAdoDetICBPER',$p['ICBPER']);

				$this->adopciondetalle_model->Crear($ad);
			}
		} */
        echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                  </div>';
    }

    public function EliminarAdopcion()
    {
        $this->adopcion_model->Eliminar($_POST['Adopcion_Id']);
    }

    public function ImprimibleAdopcion()
    {
        $adopcion = $this->adopcion_model->Buscar($_REQUEST['Adopcion_Id']);
        $r = $adopcion[0];
        require_once 'view/webforms/PDF/Adopcion.php';
    }

    public function TipoPrvClienListarTipo($tipo,$show_defafult=true)
    {
        $provclien = $this->origendestino_model->Listar2();
        $res = $show_defafult?'<option value="">Seleccione cliente/proveedor</option>':null;
        foreach ($provclien as $p) {
            if ($p->__GET('nODTipo') == $tipo) {
                $res .= sprintf('<option value="%s" data-subtext="%s" data-direccion="%s" data-ubigeo="%s" data-diascredito="%s">%s</option>',
                    $p->__GET('OrigenDestino_Id'),
                    $p->__GET('sODRucDni'),
                    $p->__GET('sODDireccion'),
                    sprintf('%s-%s-%s',$p->__GET('nProcliDepName'),$p->__GET('nProcliProvName'),$p->__GET('nProcliDistName')),
                    $p->__GET('nODDiasCredito'),
                    $p->__GET('sODNombreComercial') 
                );
            }
        }
		return $res;
    }

	public function ListarServicios(){
        $productos = $this->prodserv_model->Listar2();
		require_once 'view/webforms/tipomovimiento/salida_venta.php';
	}

	public function ObtenerNombreYUnidad(){
		$Unidadmedida_Id = $_POST['Unidadmedida_Id'];
		$ProdServ_Id = $_POST['ProdServ_Id'];

		$res = array(
			'UnidadMedida' => $this->unidadmedida_model->Buscar($Unidadmedida_Id)[0]->__GET('sUndAlias'),
			'ProdServ' => $this->prodserv_model->Buscar($ProdServ_Id)[0]->__GET('sProSrvNombre')
		);

		die(json_encode($res));
	}
	

    public function UnidadNombre($Unidadmedida_Id)
    {
        $dato = $this->unidadmedida_model->Buscar($Unidadmedida_Id);
        foreach ($dato as $d) {
            return $d->__GET('sUndAlias');
        }
    }

    public function ProdservdNombre($ProdServ_Id)
    {
        $data = $this->prodserv_model->Buscar($ProdServ_Id);
        foreach ($data as $pro) {
            return $pro->__GET('sProSrvNombre');
        }
    }
}
