<?php

require_once 'model/usuario.entidad.php';
require_once 'model/usuario.model.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/caja.model.php';
require_once 'model/caja.entidad.php';
// require_once 'model/regdocumentos.entidad.php';
// require_once 'model/regdocumentos.model.php';
require_once 'controller/metodos.controller.php';
class CajaController
{

   private $usuario_model;
   private $parametro_model;
   private $caja_model;
   private $documento_model;
   private $regdocumentos_model;
   private $metodos_controller;

   public function __CONSTRUCT()
   {
      $this->usuario_model = new UsuarioModel();
      $this->parametro_model = new ParametroModel();
      $this->caja_model = new CajaChicaModel();
      $this->documento_model = new DocumentoModel();
      //   $this->regdocumentos_model= new RegistroDocumentosModel();
      $this->metodos_controller = new MetodosController();
   }

   public function str_uppercase($valor)
   {
      return mb_strtoupper($valor, 'utf-8');
   }

   public function Index()
   {
      $parametro = $this->parametro_model->ListarParametros();
      $caja = $this->caja_model->ListarDate(
         isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime(date('d-m-Y'))),
         isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y')))
      );


      require_once 'view/header.php';
      require_once 'view/webforms/wfacaja.php';

      echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
      require_once 'view/footer.php';
   }


   public function FrmGuardarCaja()
   {
      // $Documento_Id= $_POST['Documento_Id'];
      // $this->documento_model->Incrementa($Documento_Id);
      $liquidacion = $this->caja_model->Saldo();
      $parametro = $this->parametro_model->ListarParametros();
      $documentos = $this->documento_model->Listar();
      require_once 'view/webforms/wfacajachicaa.php';
   }

   public function FrmEditarCaja()
   {

      $datos = $this->caja_model->Buscar($_POST['cajachica_id']);
      $documentos = $this->documento_model->Listar();
      foreach ($datos as $r) :
         require_once 'view/webforms/wfacajachicaa.php';
      endforeach;
   }


   public function GuardarCaja()
   {

      $caja = new CajaChica();
      if ($_POST['cajachica_id'] != 0 ? $caja->__SET('cajachica_id', $_POST['cajachica_id']) : '');
      $caja->__SET('sCajaNumero', $this->str_uppercase($_POST['sCajaNumero']));
      $caja->__SET('dCajaFecha', $_POST['dCajaFecha']);
      $caja->__SET('nCajaSaldoAnterior', $this->str_uppercase($_POST['nCajaSaldoAnterior']));
      $caja->__SET('nCajaReembolso', $this->str_uppercase($_POST['nCajaReembolso']));
      $caja->__SET('nCajaImpInicial', $this->str_uppercase($_POST['nCajaImpInicial']));
      $caja->__SET('nCajaUsu_id', $_SESSION['usu_codigo']);
      if ($_POST['cajachica_id'] == 0 ? $this->caja_model->Crear($caja) : $this->caja_model->Editar($caja));
      $this->documento_model->Incrementa(15);
   }


   public function mostrarCaja()
   {

      $caja = $this->caja_model->Buscar($_POST['cajachica_id']);
      // foreach ($clientes as $r) :
      //     if ($r->__GET('nODTipo') == 1) {
      //     $tipo = "Proveedor";
      // } elseif ($r->__GET('nODTipo') == 2) {
      //     $tipo = "Cliente";
      // } else {
      //     $tipo = "Reportes";
      // }
      foreach ($caja as $r) :

         echo " <table class='table table-hover table-bordered'> <tbody>
                          <tr>
                             <td>
                                <input type='hidden' name='cajachica_id' id='cajachica_id' value='" . $r->cajachica_id . "'> 
                                Nro:
                             </td>
                             <td>" . $r->sCajaNumero . "</td>
                          </tr>
                          <tr>
                             <td>Fecha</td>
                             <td>" . $r->dCajaFecha . "</td>
                          </tr>
                          <tr>
                             <td>Importe inicial</td>
                             <td>" . $r->nCajaImpInicial . "</td>
                          </tr>
                          <tr>
                             <td>Saldo anterior</td>
                             <td>" . $r->nCajaSaldoAnterior . "</td>
                          </tr>
                          <tr>
                             <td>Reembolso</td>
                             <td>" . $r->nCajaReembolso . "</td>
                          </tr>
                          <tr>
                             <td>Saldo</td>
                             <td>" . $r->nCajaSaldo . "</td>
                          </tr>
                         
                       </tbody> </table>
                     ";

      endforeach;
   }

   public function mostrarCajaxLiquidar()
   {

      $caja = $this->caja_model->Buscar($_POST['cajachica_id']);

      foreach ($caja as $r) :

         echo " <table class='table table-hover table-bordered'> <tbody>
                          <tr>
                             <td>
                                <input type='hidden' name='cajachica_id' id='cajachica_id' value='" . $r->cajachica_id . "'> 
                                Nro:
                             </td>
                             <td>" . $r->sCajaNumero . "</td>
                          </tr>
                          <tr>
                             <td>Fecha</td>
                             <td>" . $r->dCajaFecha . "</td>
                          </tr>
                            <tr>
                             <td>Fecha liquidación</td>
                               <td>" . date('d-m-Y') . "</td>
                          </tr>
                          <tr>
                             <td>Importe inicial</td>
                             <td>" . $r->nCajaImpInicial . "</td>
                          </tr>
                          <tr>
                             <td>Total gastos</td>
                             <td>" . $r->nCajaSalidas . "</td>
                          </tr>
                          <tr>
                             <td>Saldo</td>
                             <td>" . $r->nCajaSaldo . "</td>
                          </tr>
                         
                       </tbody> </table>
                     ";

      endforeach;
   }


   public function EliminarCaja()
   {
      $ven = new CajaChica();
      $ven->__SET('cajachica_id', $_POST['cajachica_id']);
      $this->caja_model->Eliminar($ven);
      echo '<script type="text/javascript">window.location="?c=Caja&a=Index";</script>';
   }

   public function liquidarCaja()
   {
      $ven = new CajaChica();
      $ven->__SET('cajachica_id', $_POST['cajachica_id']);
      $this->caja_model->Liquidar($ven);
      echo '<script type="text/javascript">window.location="?c=Caja&a=Index";</script>';
   }

   public function cajaPDF()
   {

      $cajachica_id = (int) $_GET['cajachica_id'];
      $caja = $this->caja_model->Buscar($cajachica_id);
      $c = $caja[0];

      require_once 'view/webforms/PDF/caja.php';
   }
}
