<?php
header('Access-Control-Allow-Origin: *'); 
require_once 'extends/request-services.php';
require_once 'model/notacredito.model.php';
require_once 'model/notacreditodetalle.model.php';
require_once 'model/guiaremision.model.php';
require_once 'model/guiaremisiondetalle.model.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/movimientopagos.entidad.php';
require_once 'model/movimientodetalle.model.php';
require_once 'model/movimientodetalle.entidad.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'model/origendestino.model.php';
require_once 'model/origendestino.entidad.php';
require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
class ElectronicController extends MetodosController
{
    public $url;
    public $movimiento_model;
    public $movimientodetalle_model;
    public $origendestino_model;
    public $unidadmedida_model;
    public $notacredito_model;
    public $guiaremision_model;
    public $guiaremisiondetalle_model;
    public function __CONSTRUCT()
    {
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->movimiento_model = new MovimientoModel();
        $this->movimientodetalle_model = new MovimientodetalleModel();
        $this->origendestino_model = new OrigendestinoModel();
        $this->notacredito_model = new NotacreditoModel();
        $this->nodatecreditodetalle_model = new NotacreditodetalleModel();
        $this->guiaremision_model = new GuiaremisionModel();
        $this->guiaremisiondetalle_model = new GuiaremisiondetalleModel();
        $this->parametro_model = new ParametroModel();
        // $this->url = 'http://colibri-fm.ddns.net:8087/servicio/Transaccion'; //antiguo
        $this->url = 'http://colibri2.fmsac.com/colibri.php';
    }

    public function Transaction($Movimiento_Id)
    {
        $request = new RequestServices();
        $request->url = $this->url;
        $movimiento = $this->movimiento_model->Buscar($Movimiento_Id);
        // print_r($movimiento);
        $details = array();
        $detraccion = $this->parametro_model->obtenerParametro(6)['sParValor'];

        foreach ($movimiento as $r) {
            $detalle_movimiento = $this->movimientodetalle_model->Buscar($r->__GET('Movimiento_Id'));
            foreach ($detalle_movimiento as $detmov) {
                $nTDeIGV = 0;
                $nTDePrecio = $detmov->__GET('nMovDetPrecioUnitario') * 1.18;
                $nMovDetImporte = $detmov->__GET('nMovDetImporte');
                $nTDeIGV = 0;
                if ($_SESSION['usu_enterpriseExoneratedIGV'] == 0) {
                    if ($detmov->__GET('nProSrvExoneradoIGV') == 0 && $r->__GET('nDocAfectoIGV') == 1) {
                        $nTDeIGV = $detmov->__GET('nMovDetImporte') * 0.18;
                    } else if($detmov->__GET('nProSrvExoneradoIGV') == 0 && $r->__GET('nDocAfectoIGV') == 0) {
                        $nTDePrecio = $nTDePrecio / 1.18;
                        $nMovDetImporte = $nMovDetImporte / 1.18;
                        $nTDeIGV = $detmov->__GET('nMovDetImporte') - $nMovDetImporte;
                    }   else if ($detmov->__GET('nProSrvExoneradoIGV') == 1 || $detmov->__GET('nProSrvExoneradoIGV') == 2) {
                        $nTDePrecio = $detmov->__GET('nMovDetPrecioUnitario');
                    }
                }
        
                $details[] = [
                    "TransaccionDetalle_Id" => $detmov->__GET('Mmovimientodetalle_Id'),
                    "Transaccion_Id" => $detmov->__GET('Movimiento_Id'),
                    "Producto_Id" => $detmov->__GET('prodserv_Id'),
                    "sProNombre" => $detmov->__GET('sProSrvNombre'),
                    "nTDeCantidad" => $detmov->__GET('nMovDetCantidad'),
                    "nTDePrecio" => $nTDePrecio,
                    "nTDeBase" => $nMovDetImporte, //$baseprice['nValorBase'],
                    "nTDeIGV" => $nTDeIGV, //$baseprice['nValorIGV'],
                    "nTDeICBPER" => $detmov->__GET('dMovDetICBPER'),
                    "nTDeSubtotal" => $nMovDetImporte + $nTDeIGV, //$baseprice['nValorTotal'],
                    "nTDeEstadoIGV" => $_SESSION['usu_enterpriseExoneratedIGV'] == 1 ? 2 : $this->getnTDeEstadoIGV($detmov->__GET('nProSrvExoneradoIGV')),
                    "nTDeEstado" => 1,
                    "sTDeEstado" => "",
                    "sUMeCodigoSunat" => $this->NombreSunatUnidadMedida($detmov->__GET('nMovDetUnidad_Id')),
                ];
            }
            
            $pagos_movimiento = $this->movimiento_model->BuscarPagos($r->__GET('Movimiento_Id'));

            foreach ($pagos_movimiento as $pagmov) {
                $details_pago[] = [
                    "FormaPago_Id" => $pagmov->__GET('MovimientoPago_Id'),
                    "Transaccion_Id" => $pagmov->__GET('Movimiento_Id'),
                    "nFPaNroCuota" => $pagmov->__GET('nMovPagNroCuota'),
                    "nFPaTotalCuota" => $pagmov->__GET('nMovPagTotalCuota'),
                    "dFPaFechaCuota" => $pagmov->__GET('dMovPagFechaCuota'),
                    "dFPaEstado" => 1,
                ];
            }
            $request->parameters = [
                [
                    "Transaccion_Id" => $r->__GET('Movimiento_Id'),
                    "TipoDocumento_Id" => $r->__GET('Documento_Id'),
                    "sNumeroGenerado" => $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento'),
                    "Empresa_Id" => 2,
                    "Moneda_Id" => $r->__GET('Moneda_Id'),
                    "nTraEsGratuito" => 0,
                    "nTraSubTotalSinIGV" => (float) number_format($r->__GET('nMovImporte'), 2, '.', ''),
                    "nTraEsAnticipo" => 0,
                    "nTraImporteTotal" => (float) number_format($r->__GET('nMovTotal'), 2, '.', ''),
                    "dTraFecha" => date('Y-m-d', strtotime($r->__GET('dMovFecha'))) . "T00:00:00",
                    "nCReCodigoSunat" => "",
                    "sCategoriaReclamo" => "",
                    "sCliNroIdentidad" => $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
                    "sCliDomicilioFiscal" => $this->DireccionClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
                    "sCliUbigeoNombre" => $this->UbigeoNombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')),
                    "sCliPaisBreve" => "PE",
                    "sCliente" => $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')), // "VICTOR ARTURO NIEVE MAQUI"
                    "nTraMontoIGV" => $r->__GET('nMovIGV'),
                    // "nTraICBPER" => 1,
                    "nTraICBPER" => $r->__GET('dMovICBPER') >0 ? 1 : 0,
                    "nTraMontoICBPER" => $r->__GET('dMovICBPER'),
                    "sTraSerie" => $r->__GET('sDocNombreCorto'),
                    "sTraNumero" => $r->__GET('sMovDocumento'),
                    "nTraEstadoTransaccionElectronica" => 0,
                    "nTraEstado" => 1,
                    "sTraEstadoTransaccionElectronica" => "ENVIADO A SUNAT",
                    "nTraTieneDetraccion" => $r->__GET('dMovDetraccion') > 0 ? 1 : 0,
                    // "nTraPctjDetraccion" => (float) number_format($r->__GET('dMovDetraccion') > 0 ? $r->__GET('dMovDetraccion') * 100 / $r->__GET('nMovTotal') : 0, 2, '.', ''),
                    "nTraPctjDetraccion" => $detraccion,
                    "nTraMontoDetraccion" => (float) number_format($r->__GET('dMovDetraccion') * $r->__GET('nMovTipoCambio'), 2, '.', ''),
                    "nTipoDocRelacionado" => 0,
                    "sSerieNumeroRelacionado" => "",
                    "sTraRUCEmpresa" => $_SESSION['usu_enterpriseRuc'],
                    "sTraObservaciones" => $r->__GET('sMovObservacion'),
                    "sTraEmail" => $r->__GET('sODCorreo'),
                    "sCliTipoIdentidad" => $r->__GET('nODTipoDoc'),
                    "nTraFormaPago" => $r->__GET('nMovTipopago') == 1 ? 1 : 2,
                    "sCliTelefono" => $r->__GET('sODTelefono'),
                    "LstTransaccionDetalle" => $details,
                    "LstFormaPago" => $r->__GET('nMovTipopago') == 2 ? $details_pago : '',
                ],
            ];
        }

        $result = $request->servicePost();
        $result = str_replace('"', '', $result);
        $message = json_encode($request->parameters) . "\r\n";
        $message .= "RESULTADO: " . $result . "\r\n";
        $this->addLogs("FACTURACION ELECTRONICA", $message);
        // $estado = 0;
        if ($result == "1") {
            // $estado = 1;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Exito información enviada</strong>, los datos fueron enviados correctamente.
                    </div>';
                    
        } else if ($result == "0") {
            // $estado = 2;
            echo '<div class="alert alert-warning" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, Insertado pero no enviado a sunat
                    </div>';
        } else if ($result == "2") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>';
                    
        } else if ($result == "3") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>';
                    
        } else if ($result == "700") {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, servicio no disponible, intente nuevamente en un momento.
                    </div>';
                    
        }else {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, surgio un problema con el servicio.
                    </div>';
        }
        $this->movimiento_model->updaeteEstado($Movimiento_Id, $result);
    }

    public function Notacredito($notacredito_Id)
    {
        $request = new RequestServices();
        $request->url = $this->url;
        $notacredito = $this->notacredito_model->Buscar($notacredito_Id);
        $details = array();

        foreach ($notacredito as $r) {
            $notacreditodetalle = $this->nodatecreditodetalle_model->Listar($notacredito_Id);
            foreach ($notacreditodetalle as $detmov) {
                $nTDePrecio = $detmov->nMovDetPrecioUnitario * 1.18;
                if ($detmov->nProSrvExoneradoIGV == 1 || $detmov->nProSrvExoneradoIGV == 2) {
                    $nTDePrecio = $detmov->nMovDetPrecioUnitario;
                }
                $igv = $detmov->nProSrvExoneradoIGV == 1 ? 0 : 0.18;
                $igv_amount = ($detmov->nMovDetPrecioUnitario * $detmov->nMovDetCantidad) * $igv;
                $nTDeIGV = number_format($igv_amount, 2, ".", ".");
                $details[] = [
                    "TransaccionDetalle_Id" => $detmov->Movimientodetalleconsumo_Id, // isset($detmov->Notacreditodetalleconsumo_Id) ? $detmov->Notacreditodetalleconsumo_Id : $detmov->Notacreditodetalle_Id,
                    "Transaccion_Id" => $detmov->Movimiento_Id,
                    "Producto_Id" => $detmov->prodserv_Id,
                    "sProNombre" => $detmov->sProSrvNombre,
                    "nTDeCantidad" => $detmov->nMovDetCantidad,
                    "nTDePrecio" => $nTDePrecio,
                    "nTDeBase" => $detmov->nMovDetImporte,
                    "nTDeIGV" => $nTDeIGV,
                    "nTDeSubtotal" => $detmov->nMovDetImporte + $nTDeIGV,
                    "nTDeEstadoIGV" => $detmov->nProSrvExoneradoIGV ? 2 : 1,
                    "nTDeEstado" => 1,
                    "sTDeEstado" => "",
                    "sUMeCodigoSunat" => $this->NombreSunatUnidadMedida($detmov->nMovDetUnidad_Id),
                ];
            }
            $request->parameters = [
                [
                    "Transaccion_Id" => $r->Movimiento_Id,
                    "TipoDocumento_Id" => 3,
                    "sNumeroGenerado" => $r->sDocNombreCorto . " - " . $r->sNotDocumento,
                    "Empresa_Id" => 2,
                    "Moneda_Id" => $r->Moneda_Id,
                    "nTraEsGratuito" => 0,
                    "nTraSubTotalSinIGV" => $r->nMovImporte,
                    "nTraEsAnticipo" => 0,
                    "nTraImporteTotal" => $r->nMovTotal,
                    "dTraFecha" => date('Y-m-d', strtotime($r->dNotcreFecha)) . "T00:00:00",
                    "nCReCodigoSunat" => $r->nCReCodigoSunat,
                    "sCategoriaReclamo" => $r->nCReDescripcionSunat,
                    "sCliNroIdentidad" => $this->RucDniClienteProveedor($r->nMovOrigenDestino_Id),
                    "sCliDomicilioFiscal" => $this->DireccionClienteProveedor($r->nMovOrigenDestino_Id),
                    "sCliUbigeoNombre" => $this->UbigeoNombreClienteProveedor($r->nMovOrigenDestino_Id),
                    "sCliPaisBreve" => "PE",
                    "sCliente" => $this->NombreClienteProveedor($r->nMovOrigenDestino_Id), // "VICTOR ARTURO NIEVE MAQUI"
                    "nTraMontoIGV" => $r->nMovIGV,
                    "sTraSerie" => $r->sDocNombreCorto,
                    "sTraNumero" => $r->sNotDocumento,
                    "nTraEstadoTransaccionElectronica" => 0,
                    "nTraEstado" => 1,
                    "sTraEstadoTransaccionElectronica" => "ENVIADO A SUNAT",
                    "nTraTieneDetraccion" => 0,
                    "nTraPctjDetraccion" => 0,
                    "nTraMontoDetraccion" => 0,
                    "nTipoDocRelacionado" => $r->Documento_Id,
                    "sSerieNumeroRelacionado" => $r->sDocNombreCortoComprobante . "-" . $r->sMovDocumentoComprobante,
                    "sTraRUCEmpresa" => $_SESSION['usu_enterpriseRuc'],
                    "sTraObservaciones" => $r->sMovObservacion,
                    "sTraEmail" => $r->sODCorreo,
                    "LstTransaccionDetalle" => $details,
                ],
            ];
        }
        $result = $request->servicePost();
        $result = str_replace('"', '', $result);
        $message = json_encode($request->parameters) . "\r\n";
        $message .= "RESULTADO: " . $result . "\r\n";
        $this->addLogs("NOTA DE CREDITO", $message);
        if ($result == "1") {
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Exito información enviada</strong>, los datos fueron enviados correctamente.
                    </div>
                    <script type="text/javascript">window.open("?c=Notacredito&a=comprobante&notacredito_Id=' . $notacredito_Id . '","_blank");</script>';
        } else if ($result == "0") {
            // $estado = 2;
            echo '<div class="alert alert-warning" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, Insertado pero no enviado a sunat
                    </div>';
        } else if ($result == "2") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>
                    <script type="text/javascript">window.open("?c=Notacredito&a=comprobante&notacredito_Id=' . $notacredito_Id . '","_blank");</script>';
        } else if ($result == "3") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>
                    <script type="text/javascript">window.open("?c=Notacredito&a=comprobante&notacredito_Id=' . $notacredito_Id . '","_blank");</script>';
        } else if ($result == "700") {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, servicio no disponible, intente nuevamente en un momento.
                    </div>';
                    
        } else {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, surgio un problema con el servicio.
                    </div>';
        }
        $this->notacredito_model->updaeteEstado($notacredito_Id, $result);
    }
    public function GuiaRemision($Guiaremision_Id)
    {
        $request = new RequestServices();
        $request->url = $this->url;
        $movimiento = $this->guiaremision_model->Buscar($Guiaremision_Id);
        $details = array();
        $detalle_movimiento = $this->guiaremisiondetalle_model->Buscar($Guiaremision_Id);
        foreach ($detalle_movimiento as $detmov) {
            $details[] = [
                "TransaccionDetalle_Id" => $detmov['Guiaremisiondetalle_Id'],
                "Transaccion_Id" => $detmov['Guiaremision_Id'],
                "Producto_Id" => $detmov['Producto_Id'],
                "sProNombre" => $detmov['sProNombre'],
                "nTDeCantidad" => $detmov['nTDeCantidad'],
                "nTDePrecio" => $detmov['nTDePrecio'],
                "nTDeBase" => $detmov['nTDeBase'],
                "nTDeIGV" => $detmov['nTDeIGV'],
                "nTDeSubtotal" => $detmov['nTDeSubtotal'],
                "nTDeEstadoIGV" => $detmov['nTDeEstadoIGV'],
                "nTDeEstado" => 1,
                "sTDeEstado" => "",
                "sUMeCodigoSunat" => $detmov['sUMeCodigoSunat'],
            ];
        }
        $request->parameters = [
            [
                "Transaccion_Id" => $movimiento['Guiaremision_Id'],
                "TipoDocumento_Id" => $movimiento['TipoDocumento_Id'],
                "sNumeroGenerado" => $movimiento['sNumeroGenerado'],
                "Empresa_Id" => 2,
                "Moneda_Id" => $movimiento['Moneda_Id'],
                "nTraEsGratuito" => $movimiento['nTraEsGratuito'],
                "nTraSubTotalSinIGV" => $movimiento['nTraSubTotalSinIGV'],
                "nTraEsAnticipo" => $movimiento['nTraEsAnticipo'],
                "nTraImporteTotal" => $movimiento['nTraImporteTotal'],
                "dTraFecha" => date('Y-m-d', strtotime($movimiento['dTraFecha'])) . "T00:00:00",
                "nCReCodigoSunat" => $movimiento['nCReCodigoSunat'],
                "sCategoriaReclamo" => $movimiento['sCategoriaReclamo'],
                "sCliNroIdentidad" => $movimiento['sCliNroIdentidad'],
                "sCliDomicilioFiscal" => $movimiento['sCliDomicilioFiscal'],
                "sCliUbigeoNombre" => $movimiento['sCliUbigeoNombre'],
                "sTraEmail" => $movimiento['sCliEmail'],
                "sCliPaisBreve" => $movimiento['sCliPaisBreve'],
                "sCliente" => $movimiento['sCliente'],
                "nTraMontoIGV" => $movimiento['nTraMontoIGV'],
                "sTraSerie" => $movimiento['sTraSerie'],
                "sTraNumero" => $movimiento['sTraNumero'],
                "nTraEstadoTransaccionElectronica" => 0,
                "nTraEstado" => 1,
                "sTraEstadoTransaccionElectronica" => "ENVIADO A SUNAT",
                "nTraTieneDetraccion" => $movimiento['nTraTieneDetraccion'],
                "nTraPctjDetraccion" => $movimiento['nTraPctjDetraccion'],
                "nTraMontoDetraccion" => $movimiento['nTraMontoDetraccion'],
                "nTipoDocRelacionado" => $movimiento['nTipoDocRelacionado'],
                "sSerieNumeroRelacionado" => $movimiento['sSerieNumeroRelacionado'],
                "sTraRUCEmpresa" => $movimiento['sTraRUCEmpresa'],
                "sTraObservaciones" => $movimiento['sGuiObservacion'],
                "sTraCodigoMotivoTraslado" => $movimiento['sTraCodigoMotivoTraslado'],
                "sTraMotivoTraslado" => $movimiento['sTraMotivoTraslado'],
                "sTraCodigoUnidadMedidaTraslado" => $movimiento['sTraCodigoUnidadMedidaTraslado'],
                "nTraPesoBrutoGuiaTraslado" => $movimiento['nTraPesoBrutoGuiaTraslado'],
                "sTraCodigoModalidadTraslado" => $movimiento['sTraCodigoModalidadTraslado'],
                "dTraFechaTraslado" => $movimiento['dTraFechaTraslado'],
                "sTraRUCTransportistaTraslado" => $movimiento['sTraRUCTransportistaTraslado'],
                "sTraNombreTransportistaTraslado" => $movimiento['sTraNombreTransportistaTraslado'],
                "sTraPlacaVehiculoTraslado" => $movimiento['sTraPlacaVehiculoTraslado'],
                "sTraDNIConductorTraslado" => $movimiento['sTraDNIConductorTraslado'],
                "sTraCodigoUbigeoPuntoLlegadaTraslado" => $movimiento['sTraCodigoUbigeoPuntoLlegadaTraslado'],
                "sTraDireccionPuntoLlegadaTraslado" => $movimiento['sTraDireccionPuntoLlegadaTraslado'],
                "sTraCodigoUbigeoPuntoPartidaTraslado" => $movimiento['sTraCodigoUbigeoPuntoPartidaTraslado'],
                "sTraDireccionPuntoPartidaTraslado" => $movimiento['sTraDireccionPuntoPartidaTraslado'],
                "LstTransaccionDetalle" => $details,
            ],
        ];
        // echo json_encode($request->parameters);
        $result = $request->servicePost();
        $result = str_replace('"', '', $result);
        $message = json_encode($request->parameters) . "\r\n";
        $message .= "RESULTADO: " . $result . "\r\n";
        $this->addLogs("GUIA REMISION ELECTRONICA", $message);
        // $estado = 0;
        if ($result == "1") {
            // $estado = 1;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Exito información enviada</strong>, los datos fueron enviados correctamente.
                    </div>
                    <script type="text/javascript">window.open("?c=Guiaremision&a=comprobante&code=' . $Guiaremision_Id . '","_blank");</script>';
        } else if ($result == "0") {
            // $estado = 2;
            echo '<div class="alert alert-warning" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, Insertado pero no enviado a sunat
                    </div>';
        } else if ($result == "2") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>';
        } else if ($result == "3") {
            // $estado = 3;
            echo '<div class="alert alert-success" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Advertencia</strong>, el documento ya fue validado.
                    </div>
                    <script type="text/javascript">window.open("?c=Guiaremision&a=comprobante&code=' . $Guiaremision_Id . '","_blank");</script>';
        } else if ($result == "700") {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, servicio no disponible, intente nuevamente en un momento.
                    </div>';
                    
        } else {
            echo '<div class="alert alert-danger" role="alert">
                        <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <strong>Error</strong>, surgio un problema con el servicio.
                    </div>';
        }
        $this->guiaremision_model->updaeteEstado($Guiaremision_Id, $result);
    }
    public function getnTDeEstadoIGV($nProSrvExoneradoIGV)
    {
        switch ($nProSrvExoneradoIGV) {
            case 0:
                return 1;
            case 1:
                return 2;
            case 2:
                return 3;
        }
    }

}
