<?php 

require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/guiaremision.model.php';
require_once 'model/guiaremision.entidad.php';
require_once 'model/guiaremisiondetalle.model.php';
require_once 'model/almacen.model.php';
require_once 'model/almacen.entidad.php';
require_once 'model/motivotraslado.model.php';
require_once 'model/documento.model.php';
require_once 'model/documento.entidad.php';
require_once 'model/tipotransporte.model.php';
require_once 'model/unidadmedida.model.php';
require_once 'model/unidadmedida.entidad.php';
require_once 'controller/electronic.controller.php';



class GuiaremisionController
{
    private $parametro_model;
    private $guiaremision_model;
    private $guiaremisiondetalle_model;
    private $almacen_model;
    private $motivotraslado_model;
    private $documento_model;
    private $electronic_controller;
    private $tipotransporte_model;
    private $unidadmedida_model;
    private $seguridad;
    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->guiaremision_model = new GuiaremisionModel();
        $this->guiaremisiondetalle_model = new GuiaremisiondetalleModel();
        $this->almacen_model = new AlmacenModel();
        $this->motivotraslado_model = new MotivotrasladoModel();
        $this->documento_model = new DocumentoModel();
        $this->electronic_controller = new ElectronicController();
        $this->tipotransporte_model = new TipotransporteModel();
        $this->unidadmedida_model = new UnidadmedidaModel();
        $this->seguridad = new Seguridad();
    }

    public function index()
    {
        $parametro = $this->parametro_model->ListarParametros();
        // $guiaremision = $this->guiaremision_model->Listar();
        $fechaIni = isset($_REQUEST['fechaIni']) ? $_REQUEST['fechaIni'] : date('d-m-Y H:i');
        $fechaFin = isset($_REQUEST['fechaFin']) ? $_REQUEST['fechaFin'] : date('d-m-Y H:i');
        $guiaremision = $this->guiaremision_model->Guia_listardate($fechaIni, $fechaFin);

        // $guiaremision = $this->guiaremision_model->Guia_listardate(
        //     isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
        //     isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))));
        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremision.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function formulario()
    {
        $almacen = $this->almacen_model->Listar();
        $parametro = $this->parametro_model->ListarParametros();
        $motivotraslado = $this->motivotraslado_model->Listar();
        $tipotransporte = $this->tipotransporte_model->Listar();
        
        $unidadmedida = $this->unidadmedida_model->Listar();
        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisiona.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function save()
    {
        try{
            if ($_REQUEST['Guiaremision_Id'] == 0) {
                $id = $this->guiaremision_model->Crear($_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $this->guiaremisiondetalle_model->Crear([
                            'Guiaremision_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                    }
                }
                $this->documento_model->Incrementa(12);
            } else {
                $id = $_REQUEST['Guiaremision_Id'];
                $this->guiaremision_model->Update($_REQUEST['Guiaremision_Id'], $_REQUEST);
                if (isset($_REQUEST['detalle'])) {
                    $this->guiaremisiondetalle_model->Delete($_REQUEST['Guiaremision_Id']);
                    foreach (json_decode($_REQUEST['detalle']) as $item) {
                        $this->guiaremisiondetalle_model->Crear([
                            'Guiaremision_Id' => $id,
                            'nTDeEstadoIGV' => $item->nTDeEstadoIGV,
                            'sUMeCodigoSunat' => $item->sUMeCodigoSunat,
                            'sUndalias' => $item->sUndalias,
                            'nTDeCantidad' => $item->nTDeCantidad,
                            'nTDeSubtotal' => $item->nTDeSubtotal,
                            'nTDePrecio' => $item->nTDePrecio,
                            'nTDeIGV' => $item->nTDeIGV,
                            'sProNombre' => $item->sProNombre,
                            'Producto_Id' => $item->Producto_Id,
                            'nTDeBase' => $item->nTDeBase,
                        ]);
                    }
                }
            }
            echo $id;
        }catch(Exception $e){
            var_dump($e);
        }
        
    }

    public function Previsualizar()
    {
        $parametro = $this->parametro_model->ListarParametros();
        $guiaremision = $this->guiaremision_model->Buscar($_REQUEST['code']);
        require_once 'view/header.php';
        require_once 'view/webforms/wfaguiaremisionv.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function eliminar()
    {
        $this->guiaremision_model->Eliminar($_REQUEST['guiaremision_id']);
    }

    public function Enviarcomprobante()
    {
        echo $this->electronic_controller->GuiaRemision($_REQUEST['Guiaremision_Id']);
    }

    public function Buscar()
    {
        $guiasremision = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        $guiasremision['dTraFecha'] = date('d-m-Y', strtotime($guiasremision['dTraFecha']));
        $guiasremision['dTraFechaTraslado'] = date('d-m-Y', strtotime($guiasremision['dTraFechaTraslado']));
        $guiasremision['detalle'] = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        echo json_encode($guiasremision);
    }

    public function comprobante()
    {
        $guia = $this->guiaremision_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($guia);
        $detalle = $this->guiaremisiondetalle_model->Buscar($_REQUEST['Guiaremision_Id']);
        //print_r($detalle);
        
        $toPrint = sprintf('%s|%s|%s|%s|%s|%s|%s|%s|%s|%s',
            $_SESSION['usu_enterpriseRuc'],
            '09',
            $guia['sTraSerie'],
            $guia['sTraNumero'],
            '0.00',//$r->nMovIGV,
            '0.00',//$r->nMovTotal,
            date('d-m-Y', strtotime($guia['dTraFecha'])),
            (strlen($guia['sCliNroIdentidad']==8)?'1':'6'),//DNI=1;6=RUC
            $guia['sCliNroIdentidad'],
            ''
            );
        
        require_once 'view/webforms/PDF/guiaremision2.php';
    }
}
