<?php

require_once 'model/parametro.model.php';
require_once 'model/parametro.entidad.php';
require_once 'model/tipomovimiento.model.php';
require_once 'model/tipomovimiento.entidad.php';
require_once 'model/movimiento.model.php';
require_once 'model/movimiento.entidad.php';
require_once 'model/tiemposervicio.model.php';
require_once 'model/tiemposervicio.entidad.php';
require_once 'model/personal.entidad.php';
require_once 'model/personal.model.php';

class TiempoServicioController extends MetodosController
{

    public $parametro_model;
    public $tipomovimiento_model;
    public $tiemposervicio_model;
    public $movimiento_model;
    public $personal_model;
    public $IGV = 0;
    private $electronic_controller;
    private $seguridad;

    public function __CONSTRUCT()
    {
        $this->parametro_model = new ParametroModel();
        $this->tipomovimiento_model = new TipomovimientoModel();
        $this->movimiento_model = new MovimientoModel();
        $this->seguridad = new Seguridad();
        $this->tiemposervicio_model = new TiemposervicioModel();
        $this->personal_model = new PersonalModel();
        foreach ($this->parametro_model->ListarParametros() as $pa) {
            if ($pa->__GET('Parametro_Id') == 2) {
                $this->IGV = ($pa->__GET('sParValor') + 100) / 100;
            }
        }
    }

    public function Index()
    {
        $usuariocodigo = $this->seguridad->validRoleName(RolesType::admin) ? 0 : $_SESSION['usu_codigo'];
        $parametro = $this->parametro_model->ListarParametros();
        $valor = explode('|', $parametro[2]->__GET('sParValor'));
        $tipomovimientos = $this->tipomovimiento_model->Listar();
        $TipoMovimiento_Id = isset($_REQUEST['TipoMovimiento_Id']) ? $_REQUEST['TipoMovimiento_Id'] : $valor[1];

        /* $movimientos = $this->movimiento_model->ListarDate(
          isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
          isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
          $TipoMovimiento_Id,
          $usuariocodigo
          ); */
        $tiempos = $this->tiemposervicio_model->ListarTiempoServicio(
                isset($_POST['fechaInicio']) ? $_POST['fechaInicio'] : date('d-m-Y', strtotime('-1 day', strtotime(date('d-m-Y')))),
                isset($_POST['fechaFin']) ? $_POST['fechaFin'] : date('d-m-Y', strtotime(date('d-m-Y'))),
                $TipoMovimiento_Id
        );
        //print_r($movimientos);

        require_once 'view/header.php';
        require_once 'view/webforms/wfatiemposervicio.php';
        echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
        require_once 'view/footer.php';
    }

    public function FrmEditaTiempoServicio()
    {
        $tiempo = $this->tiemposervicio_model->Buscar($_POST['Movimiento_Id']);
        $personal = $this->personal_model->Listar();
        $Movimiento_Id = $_POST['Movimiento_Id'];
        $nombre_cliente = $this->tiemposervicio_model->NombreCliente($_POST['Movimiento_Id']);
        $listapersonal = [];
        $t = null;
        $conductor = null;
        if (count($tiempo) > 0) {
            $t = $tiempo[0];
            $listapersonal = $this->tiemposervicio_model->ListarPersonal($t->__GET('Tiemposervicio_Id'));
            $conductor = $this->tiemposervicio_model->BuscarConductorId($t->__GET('tiemposervicioconductor_id'));
        }

        require_once 'view/webforms/wfatiemposervicioa.php';
    }

    public function CalcularMinutosTotales($intervalo)
    {
        $days = $intervalo->format('%a');
        return ($days * 24 * 60) + ($intervalo->h * 60) + $intervalo->i;
    }

    public function AuxDevolverDiferencia()
    {
        if (isset($_POST["start_date"], $_POST["end_date"], $_POST["start_hour"], $_POST["end_hour"])) {
            $start = DateTime::createFromFormat('d-m-Y H:i', $_POST["start_date"] . ' ' . $_POST["start_hour"]);
            $end = DateTime::createFromFormat('d-m-Y H:i', $_POST["end_date"] . ' ' . $_POST["end_hour"]);

            $diferencia = $start->diff($end);
            //var_dump($start, $end);
            echo (($start > $end) ? '-' : '') . $this->CalcularMinutosTotales($diferencia);
        }
    }

    public function GuardarTiempoServicio()
    {
        echo $this->tiemposervicio_model->GuardarTiempoServicio();
    }

    public function BuscarConductor()
    {
        echo json_encode($this->tiemposervicio_model->BuscarConductor($_POST['termino']));
    }

}
