<?php
class AdopcionModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
			
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ado_listar(0)');
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new Adopcion();
                $ado->__set('Adopcion_Id', $r->Adopcion_Id);
				$ado->__set('dAdoFecha', date('d-m-Y', strtotime($r->dAdoFecha)));
				$ado->__set('nAdoCliente_Id', $r->nAdoCliente_Id);
				$ado->__set('nAdoTipoAdopcion_Id', $r->nAdoTipoAdopcion_Id);
				$ado->__set('sAdoMotivo', $r->sAdoMotivo);
				$ado->__set('nAdoEsRegalo', $r->nAdoEsRegalo);
				$ado->__set('nAdoAnios', $r->nAdoAnios);
				$ado->__set('nAdoCodigo_Id', $r->nAdoCodigo_Id);
				$ado->__set('nAdoGrupoHectarea_Id', $r->nAdoGrupoHectarea_Id);
				$ado->__set('sAdoDocumentoFE', $r->sAdoDocumentoFE);
				$ado->__set('nAdoPrecio', $r->nAdoPrecio);
				$ado->__set('nAdoTipoMoneda_Id', $r->nAdoTipoMoneda_Id);
				$ado->__set('nAdoTipoCambio', $r->nAdoTipoCambio);
				$ado->__set('sAdoCerificado', $r->sAdoCerificado);
				$ado->__set('nAdoMetodoPago_Id', $r->nAdoMetodoPago_Id);
				$ado->__set('sAdoPaypalToken', $r->sAdoPaypalToken);
				$ado->__set('sAdoPaypalPayerID', $r->sAdoPaypalPayerID);
				$ado->__set('sAdoPaypalPaymentID', $r->sAdoPaypalPaymentID);
				$ado->__set('dAdoFechaPago', date('d-m-Y', strtotime($r->dAdoFechaPago)));
				$ado->__set('nAdoEstado', $r->nAdoEstado);
				$ado->__set('nAdoEliminado', $r->nAdoEliminado);
				$ado->__set('dAdoFecha_Act', $r->dAdoFecha_Act);
				$ado->__set('Usuario_Id', $r->Usuario_Id);
				$ado->__set('Cliente', $r->Cliente);
				$ado->__set('Codigo', $r->Codigo);
				$ado->__set('GrupoHectarea', $r->GrupoHectarea);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL ado_date(?,?)");
            $stm->execute([date('Y-m-d', strtotime($fechaInicio)),date('Y-m-d', strtotime($fechaFin))]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new Adopcion();
                $ado->__set('Adopcion_Id', $r->Adopcion_Id);
				$ado->__set('dAdoFecha', date('d-m-Y', strtotime($r->dAdoFecha)));
				$ado->__set('nAdoCliente_Id', $r->nAdoCliente_Id);
				$ado->__set('nAdoTipoAdopcion_Id', $r->nAdoTipoAdopcion_Id);
				$ado->__set('sAdoMotivo', $r->sAdoMotivo);
				$ado->__set('nAdoEsRegalo', $r->nAdoEsRegalo);
				$ado->__set('nAdoAnios', $r->nAdoAnios);
				$ado->__set('nAdoCodigo_Id', $r->nAdoCodigo_Id);
				$ado->__set('nAdoGrupoHectarea_Id', $r->nAdoGrupoHectarea_Id);
				$ado->__set('sAdoDocumentoFE', $r->sAdoDocumentoFE);
				$ado->__set('nAdoPrecio', $r->nAdoPrecio);
				$ado->__set('nAdoTipoMoneda_Id', $r->nAdoTipoMoneda_Id);
				$ado->__set('nAdoTipoCambio', $r->nAdoTipoCambio);
				$ado->__set('sAdoCerificado', $r->sAdoCerificado);
				$ado->__set('nAdoMetodoPago_Id', $r->nAdoMetodoPago_Id);
				$ado->__set('sAdoPaypalToken', $r->sAdoPaypalToken);
				$ado->__set('sAdoPaypalPayerID', $r->sAdoPaypalPayerID);
				$ado->__set('sAdoPaypalPaymentID', $r->sAdoPaypalPaymentID);
				$ado->__set('dAdoFechaPago', date('d-m-Y', strtotime($r->dAdoFechaPago)));
				$ado->__set('nAdoEstado', $r->nAdoEstado);
				$ado->__set('nAdoEliminado', $r->nAdoEliminado);
				$ado->__set('dAdoFecha_Act', $r->dAdoFecha_Act);
				$ado->__set('Usuario_Id', $r->Usuario_Id);
				$ado->__set('Cliente', $r->Cliente);
				$ado->__set('Codigo', $r->Codigo);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
  
    public function Buscar($Adopcion_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL ado_listar(?)');
            $stm->execute([$Adopcion_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new Adopcion();
                $ado->__set('Adopcion_Id', $r->Adopcion_Id);
				$ado->__set('dAdoFecha', date('d-m-Y', strtotime($r->dAdoFecha)));
				$ado->__set('nAdoCliente_Id', $r->nAdoCliente_Id);
				$ado->__set('nAdoTipoAdopcion_Id', $r->nAdoTipoAdopcion_Id);
				$ado->__set('sAdoMotivo', $r->sAdoMotivo);
				$ado->__set('nAdoEsRegalo', $r->nAdoEsRegalo);
				$ado->__set('nAdoAnios', $r->nAdoAnios);
				$ado->__set('nAdoCodigo_Id', $r->nAdoCodigo_Id);
				$ado->__set('nAdoGrupoHectarea_Id', $r->nAdoGrupoHectarea_Id);
				$ado->__set('sAdoDocumentoFE', $r->sAdoDocumentoFE);
				$ado->__set('nAdoPrecio', $r->nAdoPrecio);
				$ado->__set('nAdoTipoMoneda_Id', $r->nAdoTipoMoneda_Id);
				$ado->__set('nAdoTipoCambio', $r->nAdoTipoCambio);
				$ado->__set('sAdoCerificado', $r->sAdoCerificado);
				$ado->__set('nAdoMetodoPago_Id', $r->nAdoMetodoPago_Id);
				$ado->__set('sAdoPaypalToken', $r->sAdoPaypalToken);
				$ado->__set('sAdoPaypalPayerID', $r->sAdoPaypalPayerID);
				$ado->__set('sAdoPaypalPaymentID', $r->sAdoPaypalPaymentID);
				$ado->__set('dAdoFechaPago', date('d-m-Y', strtotime($r->dAdoFechaPago)));
				$ado->__set('nAdoEstado', $r->nAdoEstado);
				$ado->__set('nAdoEliminado', $r->nAdoEliminado);
				$ado->__set('dAdoFecha_Act', $r->dAdoFecha_Act);
				$ado->__set('Usuario_Id', $r->Usuario_Id);
				$ado->__set('Cliente', $r->Cliente);
				$ado->__set('Codigo', $r->Codigo);
				$ado->__set('GrupoHectarea', $r->GrupoHectarea);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function Crear(Adopcion $data, $aux=1)
    {
		if ($aux == 2) {
			$this->pdo = DataBase::ObtenerConexion(2);
		}
        try {
            $Adopcion_Id = 0;
            $stm = $this->pdo->prepare('CALL ado_crear(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)');
            $stm->execute([
                date('Y-m-d H:i:s', strtotime($data->__get('dAdoFecha'))), 
				$data->__get('nAdoCliente_Id'), 
				$data->__get('nAdoTipoAdopcion_Id'), 
				$data->__get('sAdoMotivo'), 
				$data->__get('nAdoEsRegalo'), 
				$data->__get('nAdoAnios'), 
				$data->__get('nAdoCodigo_Id'), 
				$data->__get('nAdoGrupoHectarea_Id'), 
				$data->__get('sAdoDocumentoFE'), 
				$data->__get('nAdoPrecio'), 
				$data->__get('nAdoTipoMoneda_Id'), 
				$data->__get('nAdoTipoCambio'), 
				$data->__get('sAdoCerificado'), 
				$data->__get('nAdoMetodoPago_Id'), 
				$data->__get('sAdoPaypalToken'), 
				$data->__get('sAdoPaypalPayerID'), 
				$data->__get('sAdoPaypalPaymentID'), 
				date('Y-m-d H:i:s', strtotime($data->__get('dAdoFechaPago'))), 
				$data->__get('nAdoEstado'), 
				$data->__get('nAdoEliminado'), 
				$data->__get('Usuario_Id')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $Adopcion_Id = $r->Adopcion_Id;
            }
            return $Adopcion_Id;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Editar(Adopcion $data)
    {
        try {
            $stm = $this->pdo->prepare('CALL ado_editar(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('Adopcion_Id'), 
				date('Y-m-d H:i:s', strtotime($data->__get('dAdoFecha'))), 
				$data->__get('nAdoCliente_Id'), 
				$data->__get('nAdoTipoAdopcion_Id'), 
				$data->__get('sAdoMotivo'), 
				$data->__get('nAdoEsRegalo'), 
				$data->__get('nAdoAnios'), 
				$data->__get('nAdoCodigo_Id'), 
				$data->__get('nAdoGrupoHectarea_Id'), 
				$data->__get('sAdoDocumentoFE'), 
				$data->__get('nAdoPrecio'), 
				$data->__get('nAdoTipoMoneda_Id'), 
				$data->__get('nAdoTipoCambio'), 
				$data->__get('sAdoCerificado'), 
				$data->__get('nAdoMetodoPago_Id'), 
				$data->__get('sAdoPaypalToken'), 
				$data->__get('sAdoPaypalPayerID'), 
				$data->__get('sAdoPaypalPaymentID'), 
				date('Y-m-d H:i:s', strtotime($data->__get('dAdoFechaPago'))), 
				$data->__get('nAdoEstado'), 
				$data->__get('nAdoEliminado'), 
				$_SESSION['usu_codigo']
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Eliminar($Adopcion_Id)
    {
        try {
            $stm = $this->pdo->prepare('CALL ado_eliminar(?)');
            $stm->execute([$Adopcion_Id]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
}
?>