<?php
class AdopcionDetalleModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL adodet_listar(0)');
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new AdopcionDetalle();
                $ado->__set('AdopcionDetalle_Id', $r->AdopcionDetalle_Id);
				$ado->__set('nAdoDetAdopcion_Id', $r->nAdoDetAdopcion_Id);
				$ado->__set('nAdoDetProdServ', $r->nAdoDetProdServ);
				$ado->__set('nAdoDetAlmacen_Id', $r->nAdoDetAlmacen_Id);
				$ado->__set('nAdoDetUnidad_Id', $r->nAdoDetUnidad_Id);
				$ado->__set('nAdoDetCantidad', $r->nAdoDetCantidad);
				$ado->__set('nAdoDetPrecioUnitario', $r->nAdoDetPrecioUnitario);
				$ado->__set('nAdoDetIncluyeIGV', $r->nAdoDetIncluyeIGV);
				$ado->__set('nAdoDetExoneradoIGV', $r->nAdoDetExoneradoIGV);
				$ado->__set('nAdoDetICBPER', $r->nAdoDetICBPER);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL adodet_date(?,?)");
            $stm->execute([date('Y-m-d', strtotime($fechaInicio)),date('Y-m-d', strtotime($fechaFin))]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new AdopcionDetalle();
                $ado->__set('AdopcionDetalle_Id', $r->AdopcionDetalle_Id);
				$ado->__set('nAdoDetAdopcion_Id', $r->nAdoDetAdopcion_Id);
				$ado->__set('nAdoDetProdServ', $r->nAdoDetProdServ);
				$ado->__set('nAdoDetAlmacen_Id', $r->nAdoDetAlmacen_Id);
				$ado->__set('nAdoDetUnidad_Id', $r->nAdoDetUnidad_Id);
				$ado->__set('nAdoDetCantidad', $r->nAdoDetCantidad);
				$ado->__set('nAdoDetPrecioUnitario', $r->nAdoDetPrecioUnitario);
				$ado->__set('nAdoDetIncluyeIGV', $r->nAdoDetIncluyeIGV);
				$ado->__set('nAdoDetExoneradoIGV', $r->nAdoDetExoneradoIGV);
				$ado->__set('nAdoDetICBPER', $r->nAdoDetICBPER);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
  
    public function Buscar($AdopcionDetalle_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL adodet_listar(?)');
            $stm->execute([$AdopcionDetalle_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $ado = new AdopcionDetalle();
                $ado->__set('AdopcionDetalle_Id', $r->AdopcionDetalle_Id);
				$ado->__set('nAdoDetAdopcion_Id', $r->nAdoDetAdopcion_Id);
				$ado->__set('nAdoDetProdServ', $r->nAdoDetProdServ);
				$ado->__set('nAdoDetAlmacen_Id', $r->nAdoDetAlmacen_Id);
				$ado->__set('nAdoDetUnidad_Id', $r->nAdoDetUnidad_Id);
				$ado->__set('nAdoDetCantidad', $r->nAdoDetCantidad);
				$ado->__set('nAdoDetPrecioUnitario', $r->nAdoDetPrecioUnitario);
				$ado->__set('nAdoDetIncluyeIGV', $r->nAdoDetIncluyeIGV);
				$ado->__set('nAdoDetExoneradoIGV', $r->nAdoDetExoneradoIGV);
				$ado->__set('nAdoDetICBPER', $r->nAdoDetICBPER);
                $result[] = $ado;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function Crear(AdopcionDetalle $data)
    {
        try {
            $AdopcionDetalle_Id = 0;
            $stm = $this->pdo->prepare('CALL adodet_crear(?,?,?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('nAdoDetAdopcion_Id'), 
				$data->__get('nAdoDetProdServ'), 
				$data->__get('nAdoDetAlmacen_Id'), 
				$data->__get('nAdoDetUnidad_Id'), 
				$data->__get('nAdoDetCantidad'), 
				$data->__get('nAdoDetPrecioUnitario'), 
				$data->__get('nAdoDetIncluyeIGV'), 
				$data->__get('nAdoDetExoneradoIGV'), 
				$data->__get('nAdoDetICBPER')
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $AdopcionDetalle_Id = $r->AdopcionDetalle_Id;
            }
            return $AdopcionDetalle_Id;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Editar(AdopcionDetalle $data)
    {
        try {
            $stm = $this->pdo->prepare('CALL adodet_editar(?,?,?,?,?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('AdopcionDetalle_Id'), 
				$data->__get('nAdoDetAdopcion_Id'), 
				$data->__get('nAdoDetProdServ'), 
				$data->__get('nAdoDetAlmacen_Id'), 
				$data->__get('nAdoDetUnidad_Id'), 
				$data->__get('nAdoDetCantidad'), 
				$data->__get('nAdoDetPrecioUnitario'), 
				$data->__get('nAdoDetIncluyeIGV'), 
				$data->__get('nAdoDetExoneradoIGV'), 
				$data->__get('nAdoDetICBPER')
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Eliminar($AdopcionDetalle_Id)
    {
        try {
            $stm = $this->pdo->prepare('CALL adodet_eliminar(?)');
            $stm->execute([$AdopcionDetalle_Id]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function BuscarLote($Almacen_Id, $ProdServ_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL productolote_listar($Almacen_Id,$ProdServ_Id)");
            $stm->execute();
            return $stm->fetch(PDO::FETCH_OBJ);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
?>