<?php
class CajaChicaModel
{
    private $pdo;
    function __CONSTRUCT()
    {
        try {
            require_once 'model/database.php';
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL caja_date('" . date('Y-m-d', strtotime($fechaInicio)) . "','" . date('Y-m-d', strtotime($fechaFin)) . "')");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $caja = new CajaChica();
                $caja->__SET('cajachica_id', $r->cajachica_id);
                $caja->__SET('sCajaNumero', $r->sCajaNumero);
                $caja->__SET('dCajaFecha', date('d-m-Y', strtotime($r->dCajaFecha)));
                $caja->__SET('nCajaImpInicial', $r->nCajaImpInicial);
                $caja->__SET('nCajaIngresos', $r->nCajaIngresos);
                $caja->__SET('nCajaSalidas', $r->nCajaSalidas);
                $caja->__SET('nCajaSaldo', $r->nCajaSaldo);
                $caja->__SET('nCajaSaldoAnterior', $r->nCajaSaldoAnterior);
                $caja->__SET('nCajaReembolso', $r->nCajaReembolso);
                $caja->__SET('nCajaEstado', $r->nCajaEstado);
                $caja->__SET('nCajaEliminado', $r->nCajaEliminado);
                $caja->__SET('dCajaFecha_Act', $r->dCajaFecha_Act);
                $caja->__SET('nCajaUsu_id', $r->nCajaUsu_id);
                $result[] = $caja;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

     public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL caja_listar(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $caja = new CajaChica();
                $caja->__SET('cajachica_id', $r->cajachica_id);
                $caja->__SET('sCajaNumero', $r->sCajaNumero);
                $caja->__SET('dCajaFecha', date('d-m-Y', strtotime($r->dCajaFecha)));
                $caja->__SET('nCajaImpInicial', $r->nCajaImpInicial);
                $caja->__SET('nCajaIngresos', $r->nCajaIngresos);
                $caja->__SET('nCajaSalidas', $r->nCajaSalidas);
                $caja->__SET('nCajaSaldo', $r->nCajaSaldo);
                $caja->__SET('nCajaSaldoAnterior', $r->nCajaSaldoAnterior);
                $caja->__SET('nCajaReembolso', $r->nCajaReembolso);
                $caja->__SET('dCajaFechaLiquidacion', date('d-m-Y', strtotime($r->dCajaFechaLiquidacion)));
                $caja->__SET('nCajaEstado', $r->nCajaEstado);
                $caja->__SET('nCajaEliminado', $r->nCajaEliminado);
                $caja->__SET('dCajaFecha_Act', $r->dCajaFecha_Act);
                $caja->__SET('nCajaUsu_id', $r->nCajaUsu_id);
                $result[] = $caja;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
       public function Listar2()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL caja_listar2(0)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $caja = new CajaChica();
                $caja->__SET('cajachica_id', $r->cajachica_id);
                $caja->__SET('sCajaNumero', $r->sCajaNumero);
                $caja->__SET('dCajaFecha', date('d-m-Y', strtotime($r->dCajaFecha)));
                $caja->__SET('nCajaImpInicial', $r->nCajaImpInicial);
                $caja->__SET('nCajaIngresos', $r->nCajaIngresos);
                $caja->__SET('nCajaSalidas', $r->nCajaSalidas);
                $caja->__SET('nCajaSaldo', $r->nCajaSaldo);
                $caja->__SET('nCajaSaldoAnterior', $r->nCajaSaldoAnterior);
                $caja->__SET('nCajaReembolso', $r->nCajaReembolso);
                $caja->__SET('dCajaFechaLiquidacion', date('d-m-Y', strtotime($r->dCajaFechaLiquidacion)));
                $caja->__SET('nCajaEstado', $r->nCajaEstado);
                $caja->__SET('nCajaEliminado', $r->nCajaEliminado);
                $caja->__SET('dCajaFecha_Act', $r->dCajaFecha_Act);
                $caja->__SET('nCajaUsu_id', $r->nCajaUsu_id);
                $result[] = $caja;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    
    public function Buscar($cajachica_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL caja_listar($cajachica_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $caja = new CajaChica();
                $caja->__SET('cajachica_id', $r->cajachica_id);
                $caja->__SET('sCajaNumero', $r->sCajaNumero);
                $caja->__SET('dCajaFecha', date('d-m-Y', strtotime($r->dCajaFecha)));
                $caja->__SET('nCajaImpInicial', $r->nCajaImpInicial);
                $caja->__SET('nCajaIngresos', $r->nCajaIngresos);
                $caja->__SET('nCajaSalidas', $r->nCajaSalidas);
                $caja->__SET('nCajaSaldo', $r->nCajaSaldo);
                $caja->__SET('nCajaSaldoAnterior', $r->nCajaSaldoAnterior);
                $caja->__SET('nCajaReembolso', $r->nCajaReembolso);
                $caja->__SET('dCajaFechaLiquidacion', date('d-m-Y', strtotime($r->dCajaFechaLiquidacion)));
                $caja->__SET('nCajaEstado', $r->nCajaEstado);
                $caja->__SET('nCajaEliminado', $r->nCajaEliminado);
                $caja->__SET('dCajaFecha_Act', $r->dCajaFecha_Act);
                $caja->__SET('nCajaUsu_id', $r->nCajaUsu_id);
                $result[] = $caja;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

     public function Anterior($cajachica_id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL caja_anterior($cajachica_id)");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $caja = new CajaChica();
                $caja->__SET('cajachica_id', $r->cajachica_id);
                $caja->__SET('nCajaSaldo', $r->nCajaSaldo);
                $result[] = $caja;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Crear(CajaChica $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL caja_crear(?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('sCajaNumero'),
                date('Y-m-d', strtotime($data->__get('dCajaFecha'))),
                $data->__get('nCajaImpInicial'),
                $data->__get('nCajaIngresos'),
                $data->__get('nCajaSalidas'),
                $data->__get('nCajaSaldo'),
                $data->__get('nCajaSaldoAnterior'),
                $data->__get('nCajaReembolso'),
                1,
                0,
                $data->__get('dCajaFecha_Act'),
                $data->__get('nCajaUsu_id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito, informacin guardada</strong>. Los datos fueron registrados correctamente.
                  </div>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Editar(CajaChica $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL caja_editar(?,?,?,?,?,?,?,?,?,?,?,?,?)");
            $stm->execute(array(
                $data->__get('cajachica_id'),
                $data->__get('sCajaNumero'),
                date('Y-m-d', strtotime($data->__get('dCajaFecha'))),
                $data->__get('nCajaImpInicial'),
                $data->__get('nCajaIngresos'),
                $data->__get('nCajaSalidas'),
                $data->__get('nCajaSaldo'),
                $data->__get('nCajaSaldoAnterior'),
                $data->__get('nCajaReembolso'),
                1,
                0,
                $data->__get('dCajaFecha_Act'),
                $data->__get('nCajaUsu_id')
            ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito, informacin editada</strong>. Los datos fueron editados correctamente.
                  </div>';
            echo '<script type="text/javascript">window.location="?c=Caja&a=Index";</script>';
        } catch (Exception $e) {
            die($e->getMessage());
        }
    }

    public function Eliminar(CajaChica $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL caja_eliminar(?)");
            $stm->execute(array($data->__get('cajachica_id')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

      public function Liquidar(CajaChica $data)
    {
        try {
            $stm = $this->pdo->prepare("CALL caja_liquidar(?,?)");
            $stm->execute(array(
                $data->__get('cajachica_id'),
                $data->__get('nCajaEstado')

            ));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }


    public function Saldo()
    {
        try {
            $liquidar = [];
            $stm = $this->pdo->prepare("
                (SELECT  ROUND( fn_saldo(cajachica_id),2) AS saldo 
                FROM cajachica WHERE nCajaEliminado=0 ORDER BY cajachica_id DESC LIMIT 1)
                UNION
                (SELECT 0) LIMIT 1;");
            // $stm = $this->pdo->prepare("SELECT ROUND(fn_saldo(cajachica_id),2) AS saldo FROM cajachica ORDER BY cajachica_id DESC LIMIT 1");
             // $stm = $this->pdo->prepare("SELECT * FROM cajachica");
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $liquidar[] = $r;
            }
            return $liquidar;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

}
?>
