<?php
class FamiliaArbolModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Listar()
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL fa_listar(0)');
            $stm->execute();
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $fa = new FamiliaArbol();
                $fa->__set('FamiliaArbol_Id', $r->FamiliaArbol_Id);
				$fa->__set('dFAFecha', date('d-m-Y', strtotime($r->dFAFecha)));
				$fa->__set('sFANombre', $r->sFANombre);
				$fa->__set('nFAEstado', $r->nFAEstado);
				$fa->__set('nFAEliminado', $r->nFAEliminado);
				$fa->__set('dFAFecha_Act', $r->dFAFecha_Act);
				$fa->__set('Usuario_Id', $r->Usuario_Id);
                $result[] = $fa;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }

    public function ListarDate($fechaInicio, $fechaFin)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL fa_date(?,?)");
            $stm->execute([date('Y-m-d', strtotime($fechaInicio)),date('Y-m-d', strtotime($fechaFin))]);
            $datecurrent = new DateTime(date('Y-m-d'));
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $fa = new FamiliaArbol();
                $fa->__set('FamiliaArbol_Id', $r->FamiliaArbol_Id);
				$fa->__set('dFAFecha', date('d-m-Y', strtotime($r->dFAFecha)));
				$fa->__set('sFANombre', $r->sFANombre);
				$fa->__set('nFAEstado', $r->nFAEstado);
				$fa->__set('nFAEliminado', $r->nFAEliminado);
				$fa->__set('dFAFecha_Act', $r->dFAFecha_Act);
				$fa->__set('Usuario_Id', $r->Usuario_Id);
                $result[] = $fa;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
  
    public function Buscar($FamiliaArbol_Id)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare('CALL fa_listar(?)');
            $stm->execute([$FamiliaArbol_Id]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $fa = new FamiliaArbol();
                $fa->__set('FamiliaArbol_Id', $r->FamiliaArbol_Id);
				$fa->__set('dFAFecha', date('d-m-Y', strtotime($r->dFAFecha)));
				$fa->__set('sFANombre', $r->sFANombre);
				$fa->__set('nFAEstado', $r->nFAEstado);
				$fa->__set('nFAEliminado', $r->nFAEliminado);
				$fa->__set('dFAFecha_Act', $r->dFAFecha_Act);
				$fa->__set('Usuario_Id', $r->Usuario_Id);
                $result[] = $fa;
            }
            return $result;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    
    public function Crear(FamiliaArbol $data)
    {
        try {
            $FamiliaArbol_Id = 0;
            $stm = $this->pdo->prepare('CALL fa_crear(?,?,?,?,?)');
            $stm->execute([
                date('Y-m-d H:i:s', strtotime($data->__get('dFAFecha'))), 
				$data->__get('sFANombre'), 
				$data->__get('nFAEstado'), 
				$data->__get('nFAEliminado'), 
				$_SESSION['usu_codigo']
            ]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $FamiliaArbol_Id = $r->FamiliaArbol_Id;
            }
            return $FamiliaArbol_Id;
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Editar(FamiliaArbol $data)
    {
        try {
            $stm = $this->pdo->prepare('CALL fa_editar(?,?,?,?,?,?)');
            $stm->execute([
                $data->__get('FamiliaArbol_Id'), 
				date('Y-m-d H:i:s', strtotime($data->__get('dFAFecha'))), 
				$data->__get('sFANombre'), 
				$data->__get('nFAEstado'), 
				$data->__get('nFAEliminado'), 
				$_SESSION['usu_codigo']
            ]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
    public function Eliminar($FamiliaArbol_Id)
    {
        try {
            $stm = $this->pdo->prepare('CALL fa_eliminar(?)');
            $stm->execute([$FamiliaArbol_Id]);
        } catch (Exception $exc) {
            echo $exc->getMessage();
        }
    }
}
?>