<?php

class RubroModel {
    private $pdo;
    public function __CONSTRUCT(){
        try {
            $this->pdo = DataBase::ObtenerConexion();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function Hijos($idPadre){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rub_hijos($idPadre)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $fam = new Rubro();
                $fam->__SET('Rubro_Id', $r->Rubro_Id);
                $fam->__SET('sRubCodigo', $r->sRubCodigo);
                $fam->__SET('sRubDescripcion', $r->sRubDescripcion);
                $fam->__SET('nRubPadre', $r->nRubPadre);
                $fam->__SET('nRubEstado', $r->nRubEstado);
                $fam->__SET('nRubEliminado', $r->nRubEliminado);
                $fam->__SET('dRubFecha_Act', $r->dRubFecha_Act);
                $fam->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $fam;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    
    public function Padre(Rubro $data){
        try {
            $stm = $this->pdo->prepare("CALL rub_padre(?,?)");
            $stm->execute(array($data->__get('Rubro_Id'),
                                $data->__get('nRubPadre')));
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }  
    public function Listar(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rub_listar(0)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $fam = new Rubro();
                $fam->__SET('Rubro_Id', $r->Rubro_Id);
                $fam->__SET('sRubCodigo', $r->sRubCodigo);
                $fam->__SET('sRubDescripcion', $r->sRubDescripcion);
                $fam->__SET('nRubPadre', $r->nRubPadre);
                $fam->__SET('nRubEstado', $r->nRubEstado);
                $fam->__SET('nRubEliminado', $r->nRubEliminado);
                $fam->__SET('dRubFecha_Act', $r->dRubFecha_Act);
                $fam->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $fam;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }    
    
    public function Buscar($Rubro_Id){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rub_listar($Rubro_Id)");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $fam = new Rubro();
                $fam->__SET('Rubro_Id', $r->Rubro_Id);
                $fam->__SET('sRubCodigo', $r->sRubCodigo);
                $fam->__SET('sRubDescripcion', $r->sRubDescripcion);
                $fam->__SET('nRubPadre', $r->nRubPadre);
                $fam->__SET('nRubEstado', $r->nRubEstado);
                $fam->__SET('nRubEliminado', $r->nRubEliminado);
                $fam->__SET('dRubFecha_Act', $r->dRubFecha_Act);
                $fam->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $fam;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Guardar(Rubro $data){
        try {
            $stm = $this->pdo->prepare("CALL rub_crear(?,?,?,?,?,?)");
            $stm->execute(array(
                                $data->__get('sRubCodigo'),
                                $data->__get('sRubDescripcion'),
                                $data->__get('nRubPadre'),
                                $data->__get('nRubEstado'),
                                $data->__get('nRubEliminado'),
                                $data->__get('Usuario_Id')
                         ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información guardado</strong>, los datos fueron registrados correctamente.
                  </div>';
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Editar(Rubro $data){
        try {
            $stm = $this->pdo->prepare("CALL rub_editar(?,?,?,?,?,?,?)");
            $stm->execute(array(
                                 $data->__get('sRubCodigo'),
                                 $data->__get('sRubDescripcion'),
                                 $data->__get('nRubPadre'),
                                 $data->__get('nRubEstado'),
                                 $data->__get('nRubEliminado'),
                                 $data->__get('Usuario_Id'),
                                 $data->__get('Rubro_Id')
                                ));
            echo '<div class="alert alert-success" role="alert">
                    <button type="button" class="close" data-dismiss="alert" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                    <strong>Exito información editado</strong>, los datos fueron editados correctamente.
                  </div>';  
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function Eliminar(Rubro $data){
        try {
            $stm = $this->pdo->prepare("CALL rub_eliminar(?)");
            $stm->execute(array($data->__get('Rubro_Id')));
            echo "Se elimino correctamente";
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarServicios(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rub_listar_servicios");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $fam = new Rubro();
                $fam->__SET('Rubro_Id', $r->Rubro_Id);
                $fam->__SET('sRubCodigo', $r->sRubCodigo);
                $fam->__SET('sRubDescripcion', $r->sRubDescripcion);
                $fam->__SET('nRubPadre', $r->nRubPadre);
                $fam->__SET('nRubEstado', $r->nRubEstado);
                $fam->__SET('nRubEliminado', $r->nRubEliminado);
                $fam->__SET('dRubFecha_Act', $r->dRubFecha_Act);
                $fam->__SET('Usuario_Id', $r->Usuario_Id);
                $result[] = $fam;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function ListarRubros(){
        try {
            $result = array();
            $stm = $this->pdo->prepare("CALL rub_listar_rubros");
            $stm->execute();

            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $fam = new Rubro();
                $fam->__SET('Rubro_Id', $r->Rubro_Id);
                $fam->__SET('sRubCodigo', $r->sRubCodigo);
                $fam->__SET('sRubDescripcion', $r->sRubDescripcion);
                $fam->__SET('nRubPadre', $r->nRubPadre);
                $fam->__SET('nRubEstado', $r->nRubEstado);
                $fam->__SET('nRubEliminado', $r->nRubEliminado);
                $fam->__SET('dRubFecha_Act', $r->dRubFecha_Act);
                $fam->__SET('Usuario_Id', $r->Usuario_Id);
                $fam->__SET('sRubNombre', $r->sRubNombre);
                $result[] = $fam;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}
