<?php
class MenuoptionModel
{
    private $pdo;
    public function __CONSTRUCT() {
        try {
            require_once 'db.php';
            $this->pdo = DB::cn();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function GetAll() {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT DISTINCT om.* FROM user u
                                        INNER JOIN enterpriseuser eu ON u.Id = eu.UserId
                                        INNER JOIN roleenterpriseuser repu ON eu.Id = repu.EnterpriseuserId
                                        INNER JOIN role r ON repu.RoleId = r.Id
                                        INNER JOIN optionmenurole omr ON r.Id = omr.RoleId
                                        INNER JOIN optionmenu om ON omr.OptiONmenuId = om.Id
                                        where u.Id = ? and eu.EnterpriseId = ? and om.Status=1 and Orden IS NOT NULL order by Orden asc");
            $stm->execute([$_SESSION['usu_codigo'], $_SESSION['usu_enterpriseId']]);
            foreach($stm->fetchAll(PDO::FETCH_OBJ) as $r){
                $result[] = $r;                    
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }

    public function loadMenuOptions() {
        $optionMenu = $this->GetAll();
        $menus = array();
        foreach ($optionMenu as $value) {
            if (!isset($value->OptionmenuId)) {
                $item = $value;
                $item->children = $this->loadChildrens($optionMenu, $value->Id);
                $menus = $item;
            }
        }
        return $menus;
    }
    public function loadChildrens($menuoption, $menuoptionId) {
        $childrens = array();
        foreach ($menuoption as $menu) {
            if ($menu->OptionmenuId == $menuoptionId) {
                $item = $menu;
                $item->children = $this->loadChildrens($menuoption, $menu->Id);
                $childrens[] = $menu;
            }
        }
        return $childrens;
    }
}