<?php 

class EmterpriseModel
{
    private $pdo;
    public function __CONSTRUCT()
    {
        try {
            require_once 'db.php';
            $this->pdo = DB::cn();
            $this->pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function GetByCode($enterpriseCode)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT * FROM enterprise WHERE Code = ?");
            $stm->execute([$enterpriseCode]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function GetByUserId($UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT e.Id, e.Code, e.Name, e.TradeName, e.Email, e.Seal FROM enterprise e 
                                        INNER JOIN enterpriseuser eu ON e.Id = eu.EnterpriseId AND e.Status = 1
                                        WHERE eu.UserId = ?");
            $stm->execute([$UserId]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
    public function GetRolesByEnterpriseIdAndUserId($EnterpriseId, $UserId)
    {
        try {
            $result = array();
            $stm = $this->pdo->prepare("SELECT r.Id AS RoleId,
                                               r.Name AS RoleName
                                        FROM roleenterpriseuser reu
                                        INNER JOIN enterpriseuser eu ON reu.EnterpriseuserId = eu.Id
                                        INNER JOIN role r ON reu.RoleId = r.Id
                                        WHERE eu.EnterpriseId = ? AND eu.UserId = ?");
            $stm->execute([$EnterpriseId, $UserId]);
            foreach ($stm->fetchAll(PDO::FETCH_OBJ) as $r) {
                $result[] = $r;
            }
            return $result;
        } catch (Exception $e) {
            echo die($e->getMessage());
        }
    }
}

