<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <title>Comprobante</title> 
        <style type="text/css">
            @media print{
                @page {
                    size: portrait;
                    margin-left: 15px;
                    margin-top: 15px;
                    top:5px;
                    left:5px;
                }
            }

            body{
                font-size: 18px;
                font-family: Helvetica;
                padding: 8px;
            }

            .container{
                /*position: absolute;
                padding: 5px;
                top:0px;
                width: 100%;*/
                size: auto;
                margin: 0.1mm 0.1mm 0.1mm 0.1mm;
                /*transform: scale(0.5);*/
                transform-origin: top center; 
                /* height: 50%; */
            }

            .empresa{
                padding:1%;
                width: 70%;
                font-family: Helvetica;
                font-size: 10px;
                font-weight: normal;
                display:flex;
            }

            .empresa img{
                max-width: 100%;
                width: 40%;
                display: flex;
            }

            .empresa p{
                margin-left: 20px;
                margin-right: 20px;
            }

            .cabecera{
                width: 100%;
                display: flex;
                height: 150px;
            }

            .data-ruc{
                display: table-cell;
                vertical-align: middle;
                font-family: helvetica;
                font-weight: 600;
                text-align: center;
                position: relative;
                border: 4px solid #000;
                width: 35%;
                /* margin-left: 39%; */
            }

            .data-ruc .fact-elect{
                background-color: #cccccc;
                padding-top: 5px;
                padding-bottom: 5px;
                width: 100%;
            }

            .data-factura{
                border: 3px solid #000;
                font-family: helvetica;
                line-height:13px;
                font-size: 13px;
                display: flex;
                margin-top: 10px;
            }

            .data-factura p{}

            p span{
                font-weight:700;
                margin-right: 1%;
                width: 50%;
                line-height: 13px;
            }

            p.campo{
            	font-size: 16px;
                display: flex;
            } 

            p span.contenido-campo{
                display: table-cell;
                font-weight: normal;
                line-height: 13px;
                padding-left: 20px;
            }

            .data-factura .columna{
                width: 50%;
                padding-left: 10px;
            }

            .contenido-factura{
                margin-top: 10px;
                display:table;
                width: 100%;
                min-height: 250px;
                height: 250px;
                margin-bottom: 20px;
            }

            .contenido-factura-thead, .NumeroLetras{
                border: 3px solid #000;
                padding: 5px;
                display:flex;
            }

            .contenido-factura-th{
                display:table-cell;
                width: 20%;
                text-align: center;
                font-weight: bolder;
                padding-right: 10px;
                padding-left: 10px;
            }

            .contenido-factura-tbody{
                display:flex;
                position:relative;
                margin-bottom:7px;
            }

            .contenido-factura-tr{
                display:table-cell;
                text-align: center;
                padding-right: 10px;
                padding-left: 10px;
            }

            .contenido-factura-tbody-wrapper{
                border: 3px solid #000;
                height: 230px;
                margin-top: 15px;
                padding-top:10px;
                position:relative;
            }

            .observacion{
                font-weight: bold;
                margin-top: 10px;
                margin-bottom:10px;
                padding-left:10px;
                padding-bottom: 5px;
                position:absolute;
                bottom: 0;
            }


            .pie{
                width: 100%;
                display:flex;
                line-height: 5px !important;
            }

            .pie .pre-totales{
                padding:10px;
                border: 3px solid #000;
                margin-right:10px;
                width:35%;
            }

            .pie .pre-totales .contenido-campo{
                text-align: right;
            }

            .pie .QR{
                margin-top: -10px;
                max-height:130px;
                font-size: 9px;
                margin-right:10px;
                width: 29%;
                text-align: center;
            }

            .pie .label-totales{
                width:26%;
                padding:10px;
                text-align:right;
                border: 3px solid #000;
                border-right: 0px;
                font-weight: bolder;
            }

            .pie .totales{
                text-align: right;
                padding:10px;
                border: 3px solid #000;
                width: 10%;
                border-left: 0px;
            }
        </style>
    </head>
    <body>
        <div class="container">
            <div class="cabecera">
                <div class="empresa">
                    <img src="<?php echo RUTA_HTTP; ?>/view/webforms/PDF/logo.png" />
                    <p><span style="font-size: 18px; line-height: normal"><?php echo EMPRESA; ?></span><br /><br />
                        <?php echo DIRECCION; ?><br />
                        <?php echo UBIGEO; ?><br />
                        CUENTA BCP: <?= CTA_BCP ?><br />
                        CUENTA BANCO DE LA NACION: <?= CTA_BN ?></p>
                </div>
                <div class="data-ruc">
                    <p>R.U.C <?php echo RUC; ?></p>
                    <p class="fact-elect"><?php echo $r->__GET('sDocNombre'); ?></p>
                    <p><?php echo $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento'); ?></p>
                </div>
            </div>
            <div class="data-factura">
                <div class="columna">
                    <p class="campo"><span>SE&Ntilde;OR(ES).:</span> <span class="contenido-campo"><?php echo $this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id')); ?></span></p>
                    <p class="campo"><span>RUC.:</span> <span class="contenido-campo"><?php echo $this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id')); ?></span></p>
                    <p class="campo"><span>DIRECCION.:</span><span class="contenido-campo"><?php echo $r->__GET('DireccionOD'); ?></span></p>
                    <p class="campo"><span>FECHA VENCIMIENTO.:</span> <span class="contenido-campo"><?php echo date('d/m/Y', strtotime($r->__GET('Vencimiento'))); ?></span></p>
                </div>
                <div class="columna">
                    <p class="campo"><span>TIPO MONEDA:</span> SOLES</p>
                    <p class="campo"><span>FECHA EMISION.:</span> <span class="contenido-campo"><?php echo date('d/m/Y', strtotime($r->__GET('dMovFecha_Act'))); ?></span></p>
                    <p class="campo"><span>GUIA DE REMISION DE TRANSPORTISTA:</span><span class="contenido-campo"><?php echo $r->__GET('sMovDocReferencia'); ?></span></p>
                </div>
            </div>
            <div class="contenido-factura">
                <div class="contenido-factura-thead">
                    <div class="contenido-factura-th" style="width:60%; text-align: left;">Descripci&oacute;n</div>
                    <div class="contenido-factura-th" style="width:10%; text-align: right;">Cantidad</div>
                    <div class="contenido-factura-th" style="width:10%">UM.</div>
                    <div class="contenido-factura-th" style="width:10%; text-align: right;">Precio</div>
                    <div class="contenido-factura-th" style="width:10%; text-align: right;">Importe</div>
                </div>
                <div class="contenido-factura-tbody-wrapper">
                    <?php
                    $detalle_movimiento = $this->movimientodetalle_model->getByMovimientoId($r->__GET('Movimiento_Id'));
                    foreach ($detalle_movimiento as $detmov):
                        ?>
                        <div class="contenido-factura-tbody">
                            <div class="contenido-factura-tr" style="width:60%; text-align: left;"><?php echo $detmov['sProSrvNombre']; ?></div>
                            <div class="contenido-factura-tr" style="width:10%; text-align: right;"><?php echo $detmov['nMovDetCantidad']; ?></div>
                            <div class="contenido-factura-tr" style="width:10%"><?php echo $this->UnidadNombre($detmov['nMovDetUnidad_Id']) ?></div>
                            <div class="contenido-factura-tr" style="width:10%; text-align: right;"><?php echo $r->__GET('sMonAlias') . ' ' . number_format($detmov['nMovDetPrecioUnitario'], 2, ".", "."); ?></div>
                            <div class="contenido-factura-tr" style="width:10%; text-align: right;"><?php echo $r->__GET('sMonAlias') . ' ' . number_format($detmov['nMovDetImporte'], 2, ".", "."); ?></div>
                        </div>
                        <?php
                    endforeach;
                    ?>

                    <div class="observacion"><?php echo $r->__GET('sMovObservacion'); ?></div>
                </div>
            </div>
            <div class="NumeroLetras" style="margin-bottom: 20px">
                SON <?php echo $r->__GET('NumeroLetras'); ?>
            </div>
            
            <div class="pie">
                <div class="pre-totales">

                    <p class="campo"><span>TIPO&nbsp;PAGO:</span> <span class="contenido-campo"><?php echo $r->__GET('nMovTipopago') == '1' ? 'Contado' : 'Cr&eacute;dito'; ?></span></p>

                    <p class="campo"><span>DETRACCION</span> <span class="contenido-campo"><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('dMovDetraccion'); ?></span></p>

                    <p class="campo"><span>PERCEPCION</span> <span class="contenido-campo"><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('dMovPercepcion'); ?></span></p>

                    <p class="campo"><span>RETENCION</span> <span class="contenido-campo"><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('dMovRetencion'); ?></span></p>


                </div>
                <div class="QR">
                    <?php
                    $dataText = $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento');
                    echo '<img src="view/webforms/PDF/qrgenerator.php?qr=' . $dataText . '" />';
                    ?>
                    <br />
                    <p style="line-height: normal"><b>Puede consultar su comprobante en: </b><br /><a href="http://www.transportesamadorexpress.com/consultar">www.transportesamadorexpress.com/consultar</a></p>
                </div>
                <div class="label-totales">
                    <p>OP. GRAVADAS</p>
                    <p>IGV(18%)</p>
                    <p>TOTAL</p>
                </div>
                <div class="totales">
                    <p><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('nMovImporte'); ?></p>
                    <p><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('nMovIGV'); ?></p>
                    <p><?php echo $r->__GET('sMonAlias') . ' ' . $r->__GET('nMovTotal'); ?></p>
                </div>
            </div>
        </div>
        <script src="view/librerias/plugins/jQuery/jquery-1.11.0.min.js"></script>
        <script>
            $(document).ready(function () {
            window.print();
			const refreshCount = +localStorage.getItem('refreshCount');

			console.log(refreshCount);
			if (refreshCount < <?php echo $r->__GET('nDocNumImpresiones') ?> - 1) {
				localStorage.setItem('refreshCount', refreshCount + 1);
				window.setTimeout("window.location.reload('_self','','')", 1000);
			}
            });
        </script>
    </body>
</html>