<!DOCTYPE html>
<html lang="es">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta http-equiv="X-UA-Compatible" content="ie=edge">
        <title>Comprobante</title> 
        <style type="text/css">
            @media print{
                @page {
                    size: portrait;
                    margin-left: 15px;
                    margin-top: 15px;
                    top:5px;
                    left:5px;
                }
            }

            body{
                font-size: 18px;
                font-family: Helvetica;
                padding: 8px;
            }

            .container{
                size: auto;
                margin: 0.1mm 0.1mm 0.1mm 0.1mm;
                transform-origin: top center; 

            }

            .cabecera{
                width: 100%;
                display: flex;
                min-height: 150px;
            	margin-bottom:30px;
            }
            
            .cabecera .empresa-cliente-data{
            	/*background:red;*/
            	width:70%;
            }
            
            .cabecera .empresa-cliente-data .empresa-data{
            	width:100%;
            	font-size: 10px;
            	padding-bottom:15px;
            }
            
            .cabecera .empresa-cliente-data .empresa-data img{
            	max-width: 100%;
                width: 40%;
            }
            
            .cabecera .empresa-cliente-data .empresa-data p{
            	margin-left: 20px;
                margin-right: 20px;
            	font-size: 10px;
            }
            
            .cabecera .empresa-cliente-data .cliente-data{
            	/*background:purple;*/
            	width:100%;
            	display:flex;
            	flex-flow:row;
            	flex:100%;
            	font-size: 12px;
            }
            
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-info{
            	/*background:green;*/
            	flex:2 2 60%;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-detalle{
            	/*background:yellow;*/
            	flex:2 2 40%;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-info .item,
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-detalle .item{
            	display:flex;
            	flex-flow:row;
            	line-height: 20px;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-info .item .tag,
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-detalle .item .tag{
            	font-weight:bold;
            	flex:2 2 35%;
            	min-width:90px;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-info .item .tag{
            	flex:2 2 20%;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-detalle .item .tag{
            	margin-left:4%;
            }
            
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-info .item .detail{
            	flex:2 2 80%;
            }
            .cabecera .empresa-cliente-data .cliente-data .cliente-data-detalle .item .detail{
            	flex:2 2 61%;
            }
            
            .cabecera .empresa-ruc{
            	/*background:blue;*/
            	width:30%;
            	
            	
            }
            
            .cabecera .empresa-ruc .membrete{
            	text-align: center;
            	border: 4px solid #000;
            	border-radius:6px;
            	font-family: helvetica;
                font-weight: 600;
            	padding:10px 0;
            }
            
            .contenido{
            	width: 100%;
            }
            
            .contenido .cuerpo{
            	/*background:brown;*/
            	min-height: 300px;
            	
            }
            .contenido .cuerpo .detail-item{
            	display:flex;
            	flex-flow:row;
            	width:100%;
            }
            .contenido .cuerpo .detail-item>div{
            	padding: 0 0.3%;
            	text-align:center;
            }
            .contenido .cuerpo .detail-item.detail-item-header>div{
            	font-weight:bold;
            	border-top:3px solid #000;
            	border-bottom:3px solid #000;
            	padding: 0 -5px;
            	height:30px;
            	line-height:31px;
            	margin-bottom:3px;
            }
            .contenido .cuerpo .detail-item .detail-item-desc{
            	text-align:left;
            }
            .contenido .cuerpo .detail-item.detail-item-header .detail-item-desc{
            	border-left:3px solid #000;
            	padding-left:-3px;
            	border-top-left-radius:4px;
            	border-bottom-left-radius:4px;
            }
            .contenido .cuerpo .detail-item:not(.detail-item-header) .detail-item-importe{
            	text-align:right;
            }
            .contenido .cuerpo .detail-item.detail-item-header .detail-item-importe{
            	border-right:3px solid #000;
            	padding-right:-3px;
            	border-top-right-radius:4px;
            	border-bottom-right-radius:4px;
            }
            
            .contenido .cuerpo .detail-item .detail-item-desc{
            	/*background:yellow;*/
            	flex:2 2 52%;
            }
            
            .contenido .cuerpo .detail-item .detail-item-unimed{
            	/*background:blue;*/
            	flex:2 2 12%;
            }
            
            .contenido .cuerpo .detail-item .detail-item-cant{
            	/*background:orange;*/
            	flex:2 2 12%;
            }
            
            .contenido .cuerpo .detail-item .detail-item-precio{
            	/*background:green;*/
            	flex:2 2 12%;
            	text-align:right;
            }
            
            .contenido .cuerpo .detail-item .detail-item-importe{
            	/*background:red;*/
            	flex:2 2 12%;
            }
            
            .contenido .observaciones{
            	/*background:purple;opacity:.5;*/
            	width: 99%;
            	
            	padding:20px 0 10px 1%;
            }
            
            .pie{
            	border-top: 3px solid #000;
            	padding-top:5px;
            	width: 100%;
                display:flex;
            	flex-flow:row;
            }
            
            .pie .detail{
            	/*background:red;*/
            	flex: 2 2 67%;
            }
            .pie .detail .total-escrito{
            	/*background:yellow;*/
            	flex-flow:row;
            	display: flex;
            }
            .pie .detail .adicional{
            	/*background:lightblue;*/
            	display: flex;
            	flex-flow:row;
            }
            .pie .detail .adicional .opcionales{
            	/*background:blue;*/
            	flex:2 2 50%;
            	padding-top:20px;
            }
            .pie .detail .adicional .opcionales .opt-item:not([view="0.00"]){
            	width:100%;
            	display:flex;
            	flex-flow:row;
            }
            .pie .detail .adicional .opcionales .opt-item .opt-tag{
            	/*background:orange;*/
            	flex:2 2 60%;
            	font-weight:bold;
            }
            .pie .detail .adicional .opcionales .opt-item .opt-detail{
            	/*background:green;*/
            	flex:2 2 40%;
            	text-align:right;
            }
            .pie .detail .adicional .opcionales .opt-desc{
            	/*background:red;*/
            	width:97%;
            	font-size:14px;
            	padding: 10px 0;
            	padding-left:3%;
            	font-weight:bold;
            }
            .pie .detail .adicional .qr{
            	/*background:pink;*/
            	flex:2 2 50%;
            	text-align:center;
            }
            .pie .detail .adicional .qr p{
            	font-size:10px;
            }
            
            .pie .total{
            	/*background:green;*/
            	flex: 2 2 33%;
            }
            
            .pie .total .total-item{
            	display:flex;
            	flex-flow:row;
            	line-height: 25px;
            }
            
            .pie .total .total-item .total-tag{
            	/*background:orange;*/
            	font-weight:bold;
            	flex:2 2 55%;
            }
            
            .pie .total .total-item .total-sign{
            	/*background:brown;*/
            	font-weight:bold;
            	flex:2 2 10%;
            }
            
            .pie .total .total-item .total-detail{
            	/*background:purple;*/
            	flex:2 2 35%;
            	text-align:right;
            	padding-right:10px;
            }
            
            [view="0.00"]{
            	display:none;
            }
            
        </style>
    </head>
    <body>
        <div class="container">
        	<div class="cabecera">
        		<div class="empresa-cliente-data">
        			<div class="empresa-data">
        				<img src="./view/librerias/dist/img/logos/<?=$_SESSION['usu_enterpriseId'];?>.png" />
        				<p>
                            <?php echo $_SESSION['usu_enterpriseName']; ?><br />
                            <?php echo $_SESSION['usu_enterpriseAddress']; ?><br />
                            <?php echo $_SESSION['usu_enterpriseUbigeoName']; ?>
                    	</p>
        			</div>
        			<div class="cliente-data">
        				<div class="cliente-data-info">
        					<div class="item">
        						<div class="tag">SE&Ntilde;OR(ES).:</div>
        						<div class="detail"><?=$this->NombreClienteProveedor($r->__GET('nMovOrigenDestino_Id'))?></div>
        					</div>
        					<div class="item">
        						<div class="tag">DIRECCI&Oacute;N.:</div>
        						<div class="detail"><?=$this->DireccionClienteProveedor($r->__GET('nMovOrigenDestino_Id'))?></div>
        					</div>
        					<div class="item">
        						<div class="tag">RUC.:</div>
        						<div class="detail"><?=$this->RucDniClienteProveedor($r->__GET('nMovOrigenDestino_Id'))?></div>
        					</div>
        				</div>
        				<div class="cliente-data-detalle">
        					<div class="item">
        						<div class="tag">FECHA EMISI&Oacute;N.:</div>
        						<div class="detail"><?=date('d/m/Y', strtotime($r->__GET('dMovFecha')))?></div>
        					</div>
        					<div class="item">
        						<div class="tag">TIPO MONEDA:</div>
        						<div class="detail"><?=$r->__GET('sMonDescripcion')?></div>
        					</div>
        				</div>
        			</div>
        		</div>
        		<div class="empresa-ruc">
        			<div class="membrete">
            			<p>R.U.C <?php echo $_SESSION['usu_enterpriseRuc']; ?></p>
                        <p><?php echo $r->__GET('sDocNombre'); ?></p>
                        <p><?php echo $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento'); ?></p>
                    </div>
        		</div>
        	</div>
        	<div class="contenido">
        		<div class="cuerpo">
        			<div class="detail-item detail-item-header">
        				<div class="detail-item-desc">Descripci&oacute;n</div>
        				<div class="detail-item-unimed">UM.</div>
        				<div class="detail-item-cant">Cantidad</div>
        				<div class="detail-item-precio">Precio</div>
        				<div class="detail-item-importe">Importe</div>
        			</div>
        			<?php foreach ($detalle_movimiento as $detmov){?>
        			<div class="detail-item">
        				<div class="detail-item-desc"><?=$detmov['sProSrvNombre']?></div>
        				<div class="detail-item-unimed"><?=$this->UnidadNombre($detmov['nMovDetUnidad_Id'])?></div>
        				<div class="detail-item-cant"><?=$detmov['nMovDetCantidad']?></div>
        				<div class="detail-item-precio"><?=number_format($detmov['nMovDetPrecioUnitario'], 2, ".", ",")?></div>
        				<div class="detail-item-importe"><?=number_format($detmov['nMovDetImporte'], 2, ".", ",")?></div>
        			</div>
        			<?php }?>
        		</div>
        		<div class="observaciones"><?=$observacion?></div>
        	</div>
        	<div class="pie">
        		<div class="detail">
        			<div class="total-escrito"><b>SON:</b>&nbsp;&nbsp;<?php echo $r->__GET('NumeroLetras'); ?></div>
        			<div class="adicional">
        				<div class="opcionales">
        					<div class="opt-item" view="<?=$r->__GET('dMovPercepcion')?>">
                				<div class="opt-tag">Total de Percepci&oacute;n:</div>
                				<div class="opt-detail"><?=$r->__GET('sMonAlias')."\t\t".$r->__GET('dMovPercepcion')?></div>
                			</div>
                			<div class="opt-desc" view="<?=$r->__GET('dMovDetraccion')?>">Comprobante sujeto a Detraccion del <?=$detraccion?>% (<?=$r->__GET('sMonAlias')?> <?=$r->__GET('dMovDetraccion')?> <?=$r->__GET('sMonDescripcion')?>). N&deg; de cta. en el BN: <?=$cuenta_bn?>.</div>
        				</div>
        				<div class="qr">
        					<?php 
                            $dataText   = $r->__GET('sDocNombreCorto') . " - " . $r->__GET('sMovDocumento');
                            $dataText = $toPrint;
                            $svgTagId   = 'id-of-svg';
                            $saveToFile = false;
                            $imageWidth = 130; // px        
                            // SVG file format support
                            $svgCode = QRcode::svg($dataText, $svgTagId, $saveToFile, QR_ECLEVEL_L, $imageWidth);         
                            echo $svgCode;
                            ?>
                            <p>
                            	Representaci&oacute;nn impresa de la Factura Electr&oacute;nica
                            </p>
        				</div>
        			</div>
        		</div>
        		<div class="total">
        			<div class="total-item">
        				<div class="total-tag">Total Gravado</div>
        				<div class="total-sign"><?=$r->__GET('sMonAlias')?></div>
        				<div class="total-detail"><?=number_format($r->__GET('nMovImporte'),2,'.',',')?></div>
        			</div>
        			<div class="total-item">
        				<div class="total-tag">Total no Gravado</div>
        				<div class="total-sign"></div>
        				<div class="total-detail"></div>
        			</div>
        			<div class="total-item">
        				<div class="total-tag">Total Exonerado</div>
        				<div class="total-sign"></div>
        				<div class="total-detail"></div>
        			</div>
        			<div class="total-item">
        				<div class="total-tag">Total IGV (18%)</div>
        				<div class="total-sign"><?=$r->__GET('sMonAlias')?></div>
        				<div class="total-detail"><?=number_format($r->__GET('nMovIGV'),2,'.',',')?></div>
        			</div>
        			<div class="total-item">
        				<div class="total-tag">Importe Total</div>
        				<div class="total-sign"><?=$r->__GET('sMonAlias')?></div>
        				<div class="total-detail"><?=number_format($r->__GET('nMovTotal'),2,'.',',')?></div>
        			</div>
        		</div>
        	</div>
        </div>
        <script src="view/librerias/plugins/jQuery/jquery-1.11.0.min.js"></script>
        <script>
            $(document).ready(function () {
                 window.print(); 
            });
        </script>
    </body>
</html>